# Generated from lib/combinators.ex.exs, do not edit.
# Generated at 2022-10-07 16:18:47Z.

defmodule DateTimeParser.Combinators do
  @moduledoc false
  # credo:disable-for-this-file

  @months_map %{
    "january" => 1,
    "february" => 2,
    "march" => 3,
    "april" => 4,
    "may" => 5,
    "june" => 6,
    "july" => 7,
    "august" => 8,
    "september" => 9,
    "october" => 10,
    "november" => 11,
    "december" => 12,
    "jan" => 1,
    "feb" => 2,
    "mar" => 3,
    "apr" => 4,
    "jun" => 6,
    "jul" => 7,
    "aug" => 8,
    "sept" => 9,
    "sep" => 9,
    "oct" => 10,
    "nov" => 11,
    "dec" => 12
  }

  def to_integer(value) when is_binary(value), do: String.to_integer(value)
  def vocal_month_to_numeric_month(value), do: Map.get(@months_map, value)

  @doc """
  Parses the given `binary` as parse_datetime_us.

  Returns `{:ok, [token], rest, context, position, byte_offset}` or
  `{:error, reason, rest, context, line, byte_offset}` where `position`
  describes the location of the parse_datetime_us (start position) as `{line, offset_to_start_of_line}`.

  To column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.

  ## Options

    * `:byte_offset` - the byte offset for the whole binary, defaults to 0
    * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`
    * `:context` - the initial context value. It will be converted to a map

  """
  @spec parse_datetime_us(binary, keyword) ::
          {:ok, [term], rest, context, line, byte_offset}
          | {:error, reason, rest, context, line, byte_offset}
        when line: {pos_integer, byte_offset},
             byte_offset: pos_integer,
             rest: binary,
             reason: String.t(),
             context: map
  def parse_datetime_us(binary, opts \\ []) when is_binary(binary) do
    context = Map.new(Keyword.get(opts, :context, []))
    byte_offset = Keyword.get(opts, :byte_offset, 0)

    line =
      case Keyword.get(opts, :line, 1) do
        {_, _} = line -> line
        line -> {line, byte_offset}
      end

    case parse_datetime_us__0(binary, [], [], context, line, byte_offset) do
      {:ok, acc, rest, context, line, offset} ->
        {:ok, :lists.reverse(acc), rest, context, line, offset}

      {:error, _, _, _, _, _} = error ->
        error
    end
  end

  defp parse_datetime_us__0(rest, acc, stack, context, line, offset) do
    parse_datetime_us__4(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__2(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__3(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__2(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__4(rest, acc, stack, context, line, offset) do
    parse_datetime_us__5(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__5(
         <<"wednesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["wednesday"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime_us__5(
         <<"thursday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["thursday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__5(
         <<"saturday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["saturday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__5(
         <<"tuesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["tuesday"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__5(
         <<"sunday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["sunday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__5(
         <<"monday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["monday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__5(
         <<"friday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["friday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__5(
         <<"thurs", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["thurs"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__5(
         <<"tues", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["tues"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__5(
         <<"thur", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["thur"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__5(
         <<"wed", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["wed"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"tue", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["tue"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"thu", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["thu"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"sun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["sun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"sat", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["sat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"mon", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["mon"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(
         <<"fri", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__6(rest, ["fri"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__5(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__3(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__6(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__7(
      rest,
      [
        vocal_day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__7(rest, acc, stack, context, line, offset) do
    parse_datetime_us__8(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__8(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__9(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__8(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__9(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__9(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__10(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__10(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__1(rest, acc, stack, context, line, offset) do
    parse_datetime_us__902(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__12(rest, acc, stack, context, line, offset) do
    parse_datetime_us__355(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__14(rest, acc, stack, context, line, offset) do
    parse_datetime_us__15(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__15(rest, acc, stack, context, line, offset) do
    parse_datetime_us__16(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__16(rest, acc, stack, context, line, offset) do
    parse_datetime_us__22(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__18(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__19(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__18(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric day from 01-31 while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime_us__19(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    {:error,
     "did not expect numeric day from 01-31 while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime_us__19(rest, acc, stack, context, line, offset) do
    parse_datetime_us__20(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__20(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__17(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__21(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__18(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__22(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__23(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__22(rest, acc, stack, context, line, offset) do
    parse_datetime_us__21(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__23(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__17(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__17(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__24(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__24(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__25(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__25(rest, acc, stack, context, line, offset) do
    parse_datetime_us__29(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__27(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__26(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__28(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__27(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__29(rest, acc, stack, context, line, offset) do
    parse_datetime_us__30(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__30(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__30(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__30(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__30(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__30(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__30(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__28(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__31(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__32(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__32(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__26(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__26(rest, acc, stack, context, line, offset) do
    parse_datetime_us__44(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__34(rest, acc, stack, context, line, offset) do
    parse_datetime_us__35(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__35(rest, acc, stack, context, line, offset) do
    parse_datetime_us__36(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__36(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__36(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__36(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__36(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__36(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__36(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__36(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__36(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__36(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__36(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__36(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__36(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__36(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__37(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__36(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected word month either fully spelled or 3-letter abbreviation while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime_us__37(rest, acc, stack, context, line, offset) do
    parse_datetime_us__38(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__38(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__39(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__38(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__39(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__39(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__40(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__40(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__41(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__41(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__42(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__42(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__33(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__43(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__34(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__44(rest, acc, stack, context, line, offset) do
    parse_datetime_us__45(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__45(rest, acc, stack, context, line, offset) do
    parse_datetime_us__46(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__46(rest, acc, stack, context, line, offset) do
    parse_datetime_us__52(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__48(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__49(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__48(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__43(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__49(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__43(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__49(rest, acc, stack, context, line, offset) do
    parse_datetime_us__50(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__50(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__47(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__51(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__48(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__52(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__53(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__52(rest, acc, stack, context, line, offset) do
    parse_datetime_us__51(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__53(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__47(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__47(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__54(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__54(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__55(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__55(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__33(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__33(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__56(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__14(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__57(rest, acc, stack, context, line, offset) do
    parse_datetime_us__69(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__59(rest, acc, stack, context, line, offset) do
    parse_datetime_us__60(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__60(rest, acc, stack, context, line, offset) do
    parse_datetime_us__61(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__61(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__61(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__61(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__61(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime_us__61(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__61(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__61(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__61(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__61(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__61(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__61(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__61(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__61(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__62(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__61(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__62(rest, acc, stack, context, line, offset) do
    parse_datetime_us__63(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__63(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__64(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__63(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__64(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__64(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__65(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__65(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__66(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__66(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__67(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__67(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__58(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__68(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__59(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__69(rest, acc, stack, context, line, offset) do
    parse_datetime_us__70(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__70(rest, acc, stack, context, line, offset) do
    parse_datetime_us__71(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__71(rest, acc, stack, context, line, offset) do
    parse_datetime_us__77(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__73(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__74(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__73(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__68(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__74(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__68(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__74(rest, acc, stack, context, line, offset) do
    parse_datetime_us__75(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__75(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__72(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__76(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__73(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__77(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__78(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__77(rest, acc, stack, context, line, offset) do
    parse_datetime_us__76(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__78(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__72(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__72(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__79(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__79(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__80(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__80(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__58(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__58(rest, acc, stack, context, line, offset) do
    parse_datetime_us__84(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__82(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__81(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__83(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__82(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__84(rest, acc, stack, context, line, offset) do
    parse_datetime_us__85(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__85(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__85(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__85(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__85(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__85(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__85(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__83(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__86(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__87(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__87(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__81(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__81(rest, acc, stack, context, line, offset) do
    parse_datetime_us__88(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__88(rest, acc, stack, context, line, offset) do
    parse_datetime_us__89(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__89(rest, acc, stack, context, line, offset) do
    parse_datetime_us__95(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__91(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__92(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__91(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__92(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__92(rest, acc, stack, context, line, offset) do
    parse_datetime_us__93(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__93(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__90(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__94(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__91(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__95(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__96(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__95(rest, acc, stack, context, line, offset) do
    parse_datetime_us__94(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__96(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__90(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__90(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__97(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__97(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__98(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__98(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__99(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__57(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__100(rest, acc, stack, context, line, offset) do
    parse_datetime_us__101(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__101(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__102(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__101(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__102(rest, acc, stack, context, line, offset) do
    parse_datetime_us__104(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__104(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__105(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__104(rest, acc, stack, context, line, offset) do
    parse_datetime_us__103(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__103(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__106(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__105(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__106(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__105(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__104(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__106(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__107(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__107(rest, acc, stack, context, line, offset) do
    parse_datetime_us__111(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__109(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__108(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__110(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__109(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__111(rest, acc, stack, context, line, offset) do
    parse_datetime_us__112(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__112(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__113(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__112(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__113(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__112(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__113(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__112(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__113(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__112(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__113(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__112(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__110(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__113(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__114(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__114(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__108(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__108(rest, acc, stack, context, line, offset) do
    parse_datetime_us__126(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__116(rest, acc, stack, context, line, offset) do
    parse_datetime_us__117(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__117(rest, acc, stack, context, line, offset) do
    parse_datetime_us__118(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__118(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__118(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__118(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__118(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__118(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__118(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__118(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__118(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__118(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__118(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__118(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__118(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__118(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__119(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__118(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__119(rest, acc, stack, context, line, offset) do
    parse_datetime_us__120(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__120(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__121(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__120(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__121(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__121(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__122(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__122(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__123(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__123(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__124(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__124(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__115(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__125(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__116(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__126(rest, acc, stack, context, line, offset) do
    parse_datetime_us__127(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__127(rest, acc, stack, context, line, offset) do
    parse_datetime_us__128(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__128(rest, acc, stack, context, line, offset) do
    parse_datetime_us__134(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__130(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__131(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__130(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__125(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__131(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__125(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__131(rest, acc, stack, context, line, offset) do
    parse_datetime_us__132(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__132(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__129(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__133(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__130(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__134(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__135(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__134(rest, acc, stack, context, line, offset) do
    parse_datetime_us__133(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__135(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__129(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__129(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__136(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__136(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__137(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__137(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__115(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__115(rest, acc, stack, context, line, offset) do
    parse_datetime_us__141(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__139(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__138(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__140(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__139(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__141(rest, acc, stack, context, line, offset) do
    parse_datetime_us__142(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__142(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__143(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__142(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__143(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__142(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__143(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__142(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__143(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__142(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__143(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__142(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__140(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__143(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__144(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__144(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__138(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__138(rest, acc, stack, context, line, offset) do
    parse_datetime_us__145(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__145(rest, acc, stack, context, line, offset) do
    parse_datetime_us__146(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__146(rest, acc, stack, context, line, offset) do
    parse_datetime_us__152(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__148(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__149(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__148(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__149(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__149(rest, acc, stack, context, line, offset) do
    parse_datetime_us__150(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__150(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__147(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__151(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__148(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__152(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__153(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__152(rest, acc, stack, context, line, offset) do
    parse_datetime_us__151(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__153(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__147(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__147(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__154(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__154(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__155(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__155(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__156(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__100(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__157(rest, acc, stack, context, line, offset) do
    parse_datetime_us__169(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__159(rest, acc, stack, context, line, offset) do
    parse_datetime_us__160(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__160(rest, acc, stack, context, line, offset) do
    parse_datetime_us__161(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__161(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__161(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__161(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__161(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__161(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__161(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__161(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__161(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__161(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__161(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__161(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__161(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__161(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__162(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__161(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__156(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__162(rest, acc, stack, context, line, offset) do
    parse_datetime_us__163(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__163(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__164(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__163(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__164(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__164(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__165(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__165(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__166(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__166(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__167(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__167(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__158(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__168(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__159(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__169(rest, acc, stack, context, line, offset) do
    parse_datetime_us__170(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__170(rest, acc, stack, context, line, offset) do
    parse_datetime_us__171(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__171(rest, acc, stack, context, line, offset) do
    parse_datetime_us__177(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__173(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__174(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__173(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__168(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__174(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__168(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__174(rest, acc, stack, context, line, offset) do
    parse_datetime_us__175(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__175(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__172(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__176(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__173(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__177(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__178(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__177(rest, acc, stack, context, line, offset) do
    parse_datetime_us__176(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__178(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__172(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__172(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__179(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__179(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__180(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__180(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__158(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__158(rest, acc, stack, context, line, offset) do
    parse_datetime_us__184(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__182(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__181(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__183(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__182(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__184(rest, acc, stack, context, line, offset) do
    parse_datetime_us__185(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__185(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__186(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__185(
         <<", ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__186(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__185(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__183(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__186(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__187(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__187(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__181(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__181(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime_us__188(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime_us__181(rest, acc, stack, context, line, offset) do
    parse_datetime_us__156(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__188(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__189(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__157(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__190(rest, acc, stack, context, line, offset) do
    parse_datetime_us__191(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__191(rest, acc, stack, context, line, offset) do
    parse_datetime_us__192(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__192(rest, acc, stack, context, line, offset) do
    parse_datetime_us__198(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__194(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__195(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__194(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__195(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__195(rest, acc, stack, context, line, offset) do
    parse_datetime_us__196(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__196(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__193(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__197(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__194(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__198(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__199(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__198(rest, acc, stack, context, line, offset) do
    parse_datetime_us__197(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__199(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__193(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__193(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__200(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__200(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__201(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__201(rest, acc, stack, context, line, offset) do
    parse_datetime_us__205(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__203(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__202(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__204(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__203(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__205(rest, acc, stack, context, line, offset) do
    parse_datetime_us__206(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__206(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__206(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__206(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__206(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__206(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__206(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__204(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__207(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__208(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__208(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__202(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__202(rest, acc, stack, context, line, offset) do
    parse_datetime_us__220(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__210(rest, acc, stack, context, line, offset) do
    parse_datetime_us__211(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__211(rest, acc, stack, context, line, offset) do
    parse_datetime_us__212(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__212(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__212(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__212(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__212(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__212(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__212(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__212(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__212(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__212(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__212(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__212(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__212(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__212(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__213(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__212(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__213(rest, acc, stack, context, line, offset) do
    parse_datetime_us__214(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__214(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__215(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__214(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__215(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__215(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__216(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__216(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__217(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__217(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__218(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__218(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__209(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__219(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__210(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__220(rest, acc, stack, context, line, offset) do
    parse_datetime_us__221(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__221(rest, acc, stack, context, line, offset) do
    parse_datetime_us__222(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__222(rest, acc, stack, context, line, offset) do
    parse_datetime_us__228(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__224(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__225(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__224(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__219(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__225(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__219(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__225(rest, acc, stack, context, line, offset) do
    parse_datetime_us__226(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__226(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__223(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__227(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__224(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__228(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__229(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__228(rest, acc, stack, context, line, offset) do
    parse_datetime_us__227(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__229(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__223(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__223(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__230(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__230(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__231(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__231(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__209(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__209(rest, acc, stack, context, line, offset) do
    parse_datetime_us__235(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__233(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__232(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__234(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__233(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__235(rest, acc, stack, context, line, offset) do
    parse_datetime_us__236(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__236(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__236(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__236(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__236(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__236(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__236(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__234(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__237(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__238(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__238(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__232(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__232(rest, acc, stack, context, line, offset) do
    parse_datetime_us__239(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__239(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__240(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__239(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__240(rest, acc, stack, context, line, offset) do
    parse_datetime_us__242(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__242(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__243(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__242(rest, acc, stack, context, line, offset) do
    parse_datetime_us__241(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__241(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__243(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__243(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__242(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__244(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__245(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__245(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__246(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__190(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__247(rest, acc, stack, context, line, offset) do
    parse_datetime_us__259(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__249(rest, acc, stack, context, line, offset) do
    parse_datetime_us__250(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__250(rest, acc, stack, context, line, offset) do
    parse_datetime_us__251(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__251(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__251(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__251(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__251(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__251(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__251(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__251(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__251(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__251(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__251(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__251(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__251(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__251(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__252(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__251(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__252(rest, acc, stack, context, line, offset) do
    parse_datetime_us__253(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__253(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__254(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__253(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__254(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__254(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__255(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__255(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__256(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__256(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__257(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__257(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__248(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__258(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__249(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__259(rest, acc, stack, context, line, offset) do
    parse_datetime_us__260(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__260(rest, acc, stack, context, line, offset) do
    parse_datetime_us__261(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__261(rest, acc, stack, context, line, offset) do
    parse_datetime_us__267(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__263(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__264(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__263(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__258(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__264(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__258(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__264(rest, acc, stack, context, line, offset) do
    parse_datetime_us__265(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__265(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__262(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__266(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__263(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__267(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__268(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__267(rest, acc, stack, context, line, offset) do
    parse_datetime_us__266(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__268(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__262(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__262(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__269(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__269(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__270(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__270(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__248(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__248(rest, acc, stack, context, line, offset) do
    parse_datetime_us__274(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__272(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__271(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__273(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__272(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__274(rest, acc, stack, context, line, offset) do
    parse_datetime_us__275(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__275(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__276(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__275(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__276(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__275(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__276(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__275(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__276(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__275(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__276(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__275(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__273(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__276(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__277(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__277(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__271(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__271(rest, acc, stack, context, line, offset) do
    parse_datetime_us__278(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__278(rest, acc, stack, context, line, offset) do
    parse_datetime_us__279(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__279(rest, acc, stack, context, line, offset) do
    parse_datetime_us__285(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__281(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__282(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__281(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__282(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__282(rest, acc, stack, context, line, offset) do
    parse_datetime_us__283(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__283(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__280(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__284(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__281(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__285(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__286(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__285(rest, acc, stack, context, line, offset) do
    parse_datetime_us__284(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__286(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__280(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__280(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__287(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__287(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__288(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__288(rest, acc, stack, context, line, offset) do
    parse_datetime_us__292(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__290(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__289(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__291(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__290(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__292(rest, acc, stack, context, line, offset) do
    parse_datetime_us__293(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__293(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__294(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__293(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__294(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__293(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__294(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__293(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__294(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__293(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__294(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__293(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__291(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__294(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__295(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__295(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__289(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__289(rest, acc, stack, context, line, offset) do
    parse_datetime_us__296(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__296(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__297(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__296(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__297(rest, acc, stack, context, line, offset) do
    parse_datetime_us__299(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__299(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__300(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__299(rest, acc, stack, context, line, offset) do
    parse_datetime_us__298(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__298(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__300(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__300(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__299(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__301(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__302(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__302(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__303(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__247(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__304(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime_us__305(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime_us__304(rest, acc, stack, context, line, offset) do
    parse_datetime_us__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__305(rest, acc, stack, context, line, offset) do
    parse_datetime_us__309(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__307(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__306(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__308(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__307(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__309(rest, acc, stack, context, line, offset) do
    parse_datetime_us__310(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__310(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__311(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__310(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__311(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__310(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__311(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__310(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__311(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__310(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__311(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__310(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__308(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__311(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__312(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__312(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__306(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__306(rest, acc, stack, context, line, offset) do
    parse_datetime_us__324(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__314(rest, acc, stack, context, line, offset) do
    parse_datetime_us__315(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__315(rest, acc, stack, context, line, offset) do
    parse_datetime_us__316(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__316(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__316(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__316(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__316(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__316(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__316(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__316(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__316(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__316(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__316(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__316(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__316(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__316(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__317(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__316(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__317(rest, acc, stack, context, line, offset) do
    parse_datetime_us__318(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__318(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__318(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__319(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__319(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__320(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__320(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__321(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__321(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__322(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__322(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__313(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__323(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__314(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__324(rest, acc, stack, context, line, offset) do
    parse_datetime_us__325(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__325(rest, acc, stack, context, line, offset) do
    parse_datetime_us__326(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__326(rest, acc, stack, context, line, offset) do
    parse_datetime_us__332(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__328(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__329(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__328(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__323(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__329(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__323(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__329(rest, acc, stack, context, line, offset) do
    parse_datetime_us__330(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__330(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__327(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__331(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__328(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__332(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__333(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__332(rest, acc, stack, context, line, offset) do
    parse_datetime_us__331(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__333(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__327(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__327(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__334(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__334(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__335(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__335(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__313(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__313(rest, acc, stack, context, line, offset) do
    parse_datetime_us__339(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__337(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__336(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__338(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__337(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__339(rest, acc, stack, context, line, offset) do
    parse_datetime_us__340(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__340(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__341(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__340(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__341(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__340(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__341(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__340(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__341(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__340(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__341(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__340(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__338(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__341(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__342(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__342(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__336(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__336(rest, acc, stack, context, line, offset) do
    parse_datetime_us__343(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__343(rest, acc, stack, context, line, offset) do
    parse_datetime_us__344(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__344(rest, acc, stack, context, line, offset) do
    parse_datetime_us__350(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__346(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__347(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__346(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__347(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__347(rest, acc, stack, context, line, offset) do
    parse_datetime_us__348(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__348(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__345(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__349(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__346(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__350(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__351(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__350(rest, acc, stack, context, line, offset) do
    parse_datetime_us__349(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__351(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__345(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__345(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__352(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__352(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__353(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__353(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__354(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__304(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__355(rest, acc, stack, context, line, offset) do
    parse_datetime_us__356(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__356(rest, acc, stack, context, line, offset) do
    parse_datetime_us__357(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__357(rest, acc, stack, context, line, offset) do
    parse_datetime_us__363(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__359(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__360(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__359(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__354(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__360(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__354(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__360(rest, acc, stack, context, line, offset) do
    parse_datetime_us__361(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__361(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__358(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__362(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__359(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__363(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__364(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__363(rest, acc, stack, context, line, offset) do
    parse_datetime_us__362(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__364(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__358(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__358(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__365(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__365(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__366(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__366(rest, acc, stack, context, line, offset) do
    parse_datetime_us__370(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__368(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__367(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__369(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__368(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__370(rest, acc, stack, context, line, offset) do
    parse_datetime_us__371(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__371(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__371(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__371(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__371(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__371(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__371(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__369(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__372(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__373(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__373(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__367(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__367(rest, acc, stack, context, line, offset) do
    parse_datetime_us__374(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__374(rest, acc, stack, context, line, offset) do
    parse_datetime_us__375(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__375(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__375(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__375(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__375(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__375(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__375(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__375(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__375(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__375(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__375(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__375(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__375(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__375(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__376(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__375(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__354(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__376(rest, acc, stack, context, line, offset) do
    parse_datetime_us__377(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__377(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__378(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__377(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__378(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__378(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__379(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__379(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__380(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__380(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__381(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__381(rest, acc, stack, context, line, offset) do
    parse_datetime_us__385(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__383(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__382(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__384(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__383(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__385(rest, acc, stack, context, line, offset) do
    parse_datetime_us__386(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__386(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__387(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__386(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__387(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__386(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__387(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__386(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__387(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__386(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__387(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__386(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__384(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__387(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__388(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__388(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__382(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__382(rest, acc, stack, context, line, offset) do
    parse_datetime_us__389(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__389(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__390(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__389(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__354(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__390(rest, acc, stack, context, line, offset) do
    parse_datetime_us__392(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__392(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__393(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__392(rest, acc, stack, context, line, offset) do
    parse_datetime_us__391(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__391(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__394(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__393(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__394(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__393(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__392(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__394(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__395(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__395(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__13(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__396(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__12(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__397(rest, acc, stack, context, line, offset) do
    parse_datetime_us__740(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__399(rest, acc, stack, context, line, offset) do
    parse_datetime_us__400(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__400(rest, acc, stack, context, line, offset) do
    parse_datetime_us__401(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__401(rest, acc, stack, context, line, offset) do
    parse_datetime_us__407(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__403(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__404(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__403(rest, _acc, stack, context, line, offset) do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__404(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__404(rest, acc, stack, context, line, offset) do
    parse_datetime_us__405(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__405(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__402(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__406(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__403(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__407(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__408(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__407(rest, acc, stack, context, line, offset) do
    parse_datetime_us__406(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__408(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__402(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__402(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__409(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__409(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__410(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__410(rest, acc, stack, context, line, offset) do
    parse_datetime_us__414(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__412(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__411(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__413(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__412(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__414(rest, acc, stack, context, line, offset) do
    parse_datetime_us__415(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__415(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__416(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__415(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__416(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__415(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__416(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__415(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__416(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__415(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__416(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__415(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__413(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__416(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__417(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__417(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__411(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__411(rest, acc, stack, context, line, offset) do
    parse_datetime_us__429(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__419(rest, acc, stack, context, line, offset) do
    parse_datetime_us__420(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__420(rest, acc, stack, context, line, offset) do
    parse_datetime_us__421(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__421(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__421(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__421(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__421(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__421(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__421(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__421(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__421(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__421(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__421(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__421(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__421(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__421(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__422(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__421(rest, _acc, stack, context, line, offset) do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__422(rest, acc, stack, context, line, offset) do
    parse_datetime_us__423(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__423(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__424(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__423(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__424(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__424(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__425(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__425(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__426(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__426(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__427(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__427(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__418(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__428(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__419(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__429(rest, acc, stack, context, line, offset) do
    parse_datetime_us__430(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__430(rest, acc, stack, context, line, offset) do
    parse_datetime_us__431(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__431(rest, acc, stack, context, line, offset) do
    parse_datetime_us__437(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__433(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__434(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__433(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__428(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__434(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__428(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__434(rest, acc, stack, context, line, offset) do
    parse_datetime_us__435(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__435(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__432(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__436(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__433(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__437(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__438(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__437(rest, acc, stack, context, line, offset) do
    parse_datetime_us__436(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__438(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__432(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__432(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__439(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__439(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__440(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__440(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__418(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__418(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__441(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__399(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__442(rest, acc, stack, context, line, offset) do
    parse_datetime_us__454(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__444(rest, acc, stack, context, line, offset) do
    parse_datetime_us__445(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__445(rest, acc, stack, context, line, offset) do
    parse_datetime_us__446(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__446(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__446(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__446(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__446(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__446(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__446(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__446(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__446(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__446(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__446(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__446(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__446(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__446(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__447(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__446(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__441(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__447(rest, acc, stack, context, line, offset) do
    parse_datetime_us__448(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__448(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__449(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__448(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__449(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__449(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__450(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__450(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__451(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__451(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__452(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__452(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__443(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__453(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__444(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__454(rest, acc, stack, context, line, offset) do
    parse_datetime_us__455(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__455(rest, acc, stack, context, line, offset) do
    parse_datetime_us__456(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__456(rest, acc, stack, context, line, offset) do
    parse_datetime_us__462(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__458(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__459(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__458(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__453(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__459(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__453(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__459(rest, acc, stack, context, line, offset) do
    parse_datetime_us__460(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__460(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__457(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__461(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__458(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__462(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__463(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__462(rest, acc, stack, context, line, offset) do
    parse_datetime_us__461(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__463(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__457(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__457(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__464(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__464(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__465(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__465(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__443(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__443(rest, acc, stack, context, line, offset) do
    parse_datetime_us__469(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__467(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__466(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__468(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__467(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__469(rest, acc, stack, context, line, offset) do
    parse_datetime_us__470(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__470(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__471(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__470(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__471(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__470(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__471(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__470(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__471(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__470(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__471(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__470(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__468(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__471(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__472(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__472(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__466(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__466(rest, acc, stack, context, line, offset) do
    parse_datetime_us__473(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__473(rest, acc, stack, context, line, offset) do
    parse_datetime_us__474(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__474(rest, acc, stack, context, line, offset) do
    parse_datetime_us__480(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__476(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__477(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__476(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__441(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__477(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__441(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__477(rest, acc, stack, context, line, offset) do
    parse_datetime_us__478(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__478(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__475(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__479(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__476(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__480(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__481(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__480(rest, acc, stack, context, line, offset) do
    parse_datetime_us__479(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__481(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__475(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__475(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__482(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__482(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__483(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__483(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__484(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__442(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__485(rest, acc, stack, context, line, offset) do
    parse_datetime_us__486(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__486(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__487(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__486(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__484(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__487(rest, acc, stack, context, line, offset) do
    parse_datetime_us__489(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__489(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__490(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__489(rest, acc, stack, context, line, offset) do
    parse_datetime_us__488(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__488(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__491(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__490(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__491(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__490(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__489(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__491(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__492(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__492(rest, acc, stack, context, line, offset) do
    parse_datetime_us__496(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__494(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__493(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__495(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__494(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__496(rest, acc, stack, context, line, offset) do
    parse_datetime_us__497(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__497(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__498(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__497(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__498(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__497(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__498(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__497(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__498(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__497(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__498(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__497(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__495(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__498(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__499(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__499(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__493(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__493(rest, acc, stack, context, line, offset) do
    parse_datetime_us__511(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__501(rest, acc, stack, context, line, offset) do
    parse_datetime_us__502(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__502(rest, acc, stack, context, line, offset) do
    parse_datetime_us__503(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__503(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__503(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__503(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__503(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__503(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__503(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__503(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__503(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__503(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__503(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__503(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__503(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__503(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__504(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__503(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__484(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__504(rest, acc, stack, context, line, offset) do
    parse_datetime_us__505(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__505(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__506(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__505(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__506(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__506(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__507(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__507(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__508(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__508(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__509(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__509(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__500(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__510(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__501(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__511(rest, acc, stack, context, line, offset) do
    parse_datetime_us__512(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__512(rest, acc, stack, context, line, offset) do
    parse_datetime_us__513(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__513(rest, acc, stack, context, line, offset) do
    parse_datetime_us__519(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__515(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__516(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__515(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__510(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__516(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__510(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__516(rest, acc, stack, context, line, offset) do
    parse_datetime_us__517(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__517(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__514(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__518(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__515(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__519(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__520(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__519(rest, acc, stack, context, line, offset) do
    parse_datetime_us__518(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__520(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__514(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__514(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__521(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__521(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__522(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__522(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__500(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__500(rest, acc, stack, context, line, offset) do
    parse_datetime_us__526(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__524(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__523(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__525(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__524(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__526(rest, acc, stack, context, line, offset) do
    parse_datetime_us__527(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__527(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__527(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__527(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__527(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__527(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__527(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__525(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__528(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__529(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__529(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__523(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__523(rest, acc, stack, context, line, offset) do
    parse_datetime_us__530(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__530(rest, acc, stack, context, line, offset) do
    parse_datetime_us__531(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__531(rest, acc, stack, context, line, offset) do
    parse_datetime_us__537(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__533(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__534(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__533(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__484(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__534(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__484(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__534(rest, acc, stack, context, line, offset) do
    parse_datetime_us__535(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__535(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__532(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__536(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__533(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__537(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__538(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__537(rest, acc, stack, context, line, offset) do
    parse_datetime_us__536(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__538(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__532(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__532(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__539(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__539(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__540(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__540(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__541(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__485(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__542(rest, acc, stack, context, line, offset) do
    parse_datetime_us__554(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__544(rest, acc, stack, context, line, offset) do
    parse_datetime_us__545(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__545(rest, acc, stack, context, line, offset) do
    parse_datetime_us__546(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__546(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__546(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__546(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__546(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__546(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__546(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__546(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__546(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__546(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__546(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__546(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__546(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__546(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__547(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__546(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__541(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__547(rest, acc, stack, context, line, offset) do
    parse_datetime_us__548(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__548(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__549(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__548(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__549(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__549(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__550(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__550(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__551(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__551(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__552(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__552(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__543(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__553(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__544(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__554(rest, acc, stack, context, line, offset) do
    parse_datetime_us__555(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__555(rest, acc, stack, context, line, offset) do
    parse_datetime_us__556(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__556(rest, acc, stack, context, line, offset) do
    parse_datetime_us__562(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__558(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__559(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__558(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__553(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__559(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__553(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__559(rest, acc, stack, context, line, offset) do
    parse_datetime_us__560(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__560(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__557(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__561(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__558(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__562(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__563(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__562(rest, acc, stack, context, line, offset) do
    parse_datetime_us__561(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__563(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__557(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__557(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__564(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__564(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__565(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__565(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__543(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__543(rest, acc, stack, context, line, offset) do
    parse_datetime_us__569(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__567(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__566(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__568(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__567(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__569(rest, acc, stack, context, line, offset) do
    parse_datetime_us__570(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__570(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__571(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__570(
         <<", ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__571(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__570(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__568(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__571(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__572(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__572(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__566(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__566(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime_us__573(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime_us__566(rest, acc, stack, context, line, offset) do
    parse_datetime_us__541(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__573(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__574(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__542(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__575(rest, acc, stack, context, line, offset) do
    parse_datetime_us__576(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__576(rest, acc, stack, context, line, offset) do
    parse_datetime_us__577(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__577(rest, acc, stack, context, line, offset) do
    parse_datetime_us__583(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__579(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__580(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__579(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__574(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__580(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__574(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__580(rest, acc, stack, context, line, offset) do
    parse_datetime_us__581(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__581(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__578(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__582(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__579(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__583(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__584(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__583(rest, acc, stack, context, line, offset) do
    parse_datetime_us__582(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__584(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__578(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__578(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__585(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__585(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__586(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__586(rest, acc, stack, context, line, offset) do
    parse_datetime_us__590(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__588(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__587(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__589(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__588(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__590(rest, acc, stack, context, line, offset) do
    parse_datetime_us__591(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__591(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__592(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__591(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__592(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__591(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__592(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__591(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__592(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__591(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__592(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__591(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__589(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__592(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__593(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__593(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__587(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__587(rest, acc, stack, context, line, offset) do
    parse_datetime_us__605(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__595(rest, acc, stack, context, line, offset) do
    parse_datetime_us__596(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__596(rest, acc, stack, context, line, offset) do
    parse_datetime_us__597(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__597(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__597(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__597(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__597(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__597(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__597(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__597(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__597(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__597(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__597(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__597(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__597(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__597(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__598(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__597(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__574(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__598(rest, acc, stack, context, line, offset) do
    parse_datetime_us__599(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__599(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__600(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__599(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__600(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__600(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__601(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__601(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__602(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__602(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__603(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__603(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__594(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__604(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__595(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__605(rest, acc, stack, context, line, offset) do
    parse_datetime_us__606(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__606(rest, acc, stack, context, line, offset) do
    parse_datetime_us__607(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__607(rest, acc, stack, context, line, offset) do
    parse_datetime_us__613(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__609(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__610(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__609(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__604(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__610(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__604(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__610(rest, acc, stack, context, line, offset) do
    parse_datetime_us__611(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__611(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__608(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__612(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__609(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__613(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__614(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__613(rest, acc, stack, context, line, offset) do
    parse_datetime_us__612(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__614(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__608(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__608(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__615(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__615(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__616(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__616(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__594(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__594(rest, acc, stack, context, line, offset) do
    parse_datetime_us__620(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__618(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__617(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__619(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__618(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__620(rest, acc, stack, context, line, offset) do
    parse_datetime_us__621(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__621(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__622(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__621(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__622(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__621(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__622(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__621(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__622(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__621(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__622(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__621(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__619(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__622(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__623(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__623(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__617(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__617(rest, acc, stack, context, line, offset) do
    parse_datetime_us__624(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__624(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__625(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__624(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__574(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__625(rest, acc, stack, context, line, offset) do
    parse_datetime_us__627(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__627(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__628(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__627(rest, acc, stack, context, line, offset) do
    parse_datetime_us__626(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__626(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__629(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__628(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__629(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__628(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__627(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__629(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__630(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__630(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__631(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__575(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__632(rest, acc, stack, context, line, offset) do
    parse_datetime_us__644(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__634(rest, acc, stack, context, line, offset) do
    parse_datetime_us__635(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__635(rest, acc, stack, context, line, offset) do
    parse_datetime_us__636(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__636(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__636(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__636(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__636(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__636(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__636(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__636(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__636(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__636(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__636(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__636(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__636(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__636(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__637(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__636(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__631(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__637(rest, acc, stack, context, line, offset) do
    parse_datetime_us__638(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__638(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__639(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__638(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__639(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__639(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__640(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__640(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__641(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__641(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__642(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__642(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__633(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__643(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__634(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__644(rest, acc, stack, context, line, offset) do
    parse_datetime_us__645(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__645(rest, acc, stack, context, line, offset) do
    parse_datetime_us__646(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__646(rest, acc, stack, context, line, offset) do
    parse_datetime_us__652(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__648(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__649(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__648(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__643(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__649(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__643(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__649(rest, acc, stack, context, line, offset) do
    parse_datetime_us__650(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__650(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__647(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__651(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__648(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__652(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__653(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__652(rest, acc, stack, context, line, offset) do
    parse_datetime_us__651(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__653(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__647(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__647(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__654(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__654(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__655(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__655(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__633(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__633(rest, acc, stack, context, line, offset) do
    parse_datetime_us__659(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__657(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__656(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__658(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__657(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__659(rest, acc, stack, context, line, offset) do
    parse_datetime_us__660(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__660(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__661(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__660(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__661(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__660(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__661(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__660(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__661(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__660(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__661(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__660(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__658(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__661(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__662(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__662(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__656(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__656(rest, acc, stack, context, line, offset) do
    parse_datetime_us__663(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__663(rest, acc, stack, context, line, offset) do
    parse_datetime_us__664(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__664(rest, acc, stack, context, line, offset) do
    parse_datetime_us__670(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__666(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__667(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__666(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__631(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__667(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__631(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__667(rest, acc, stack, context, line, offset) do
    parse_datetime_us__668(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__668(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__665(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__669(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__666(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__670(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__671(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__670(rest, acc, stack, context, line, offset) do
    parse_datetime_us__669(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__671(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__665(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__665(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__672(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__672(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__673(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__673(rest, acc, stack, context, line, offset) do
    parse_datetime_us__677(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__675(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__674(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__676(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__675(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__677(rest, acc, stack, context, line, offset) do
    parse_datetime_us__678(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__678(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__679(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__678(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__679(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__678(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__679(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__678(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__679(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__678(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__679(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__678(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__676(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__679(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__680(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__680(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__674(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__674(rest, acc, stack, context, line, offset) do
    parse_datetime_us__681(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__681(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__682(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__681(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__631(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__682(rest, acc, stack, context, line, offset) do
    parse_datetime_us__684(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__684(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__685(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__684(rest, acc, stack, context, line, offset) do
    parse_datetime_us__683(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__683(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__686(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__685(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__686(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__685(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__684(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__686(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__687(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__687(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__688(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__632(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__689(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime_us__690(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime_us__689(rest, acc, stack, context, line, offset) do
    parse_datetime_us__688(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__690(rest, acc, stack, context, line, offset) do
    parse_datetime_us__694(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__692(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__691(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__693(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__692(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__694(rest, acc, stack, context, line, offset) do
    parse_datetime_us__695(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__695(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__696(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__695(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__696(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__695(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__696(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__695(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__696(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__695(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__696(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__695(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__693(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__696(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__697(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__697(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__691(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__691(rest, acc, stack, context, line, offset) do
    parse_datetime_us__709(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__699(rest, acc, stack, context, line, offset) do
    parse_datetime_us__700(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__700(rest, acc, stack, context, line, offset) do
    parse_datetime_us__701(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__701(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__701(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__701(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__701(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__701(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__701(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__701(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__701(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__701(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__701(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__701(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__701(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__701(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__702(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__701(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__688(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__702(rest, acc, stack, context, line, offset) do
    parse_datetime_us__703(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__703(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__704(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__703(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__704(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__704(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__705(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__705(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__706(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__706(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__707(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__707(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__698(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__708(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__699(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__709(rest, acc, stack, context, line, offset) do
    parse_datetime_us__710(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__710(rest, acc, stack, context, line, offset) do
    parse_datetime_us__711(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__711(rest, acc, stack, context, line, offset) do
    parse_datetime_us__717(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__713(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__714(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__713(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__708(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__714(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__708(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__714(rest, acc, stack, context, line, offset) do
    parse_datetime_us__715(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__715(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__712(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__716(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__713(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__717(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__718(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__717(rest, acc, stack, context, line, offset) do
    parse_datetime_us__716(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__718(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__712(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__712(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__719(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__719(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__720(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__720(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__698(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__698(rest, acc, stack, context, line, offset) do
    parse_datetime_us__724(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__722(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__721(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__723(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__722(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__724(rest, acc, stack, context, line, offset) do
    parse_datetime_us__725(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__725(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__726(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__725(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__726(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__725(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__726(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__725(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__726(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__725(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__726(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__725(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__723(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__726(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__727(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__727(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__721(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__721(rest, acc, stack, context, line, offset) do
    parse_datetime_us__728(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__728(rest, acc, stack, context, line, offset) do
    parse_datetime_us__729(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__729(rest, acc, stack, context, line, offset) do
    parse_datetime_us__735(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__731(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__732(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__731(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__688(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__732(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__688(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__732(rest, acc, stack, context, line, offset) do
    parse_datetime_us__733(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__733(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__730(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__734(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__731(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__735(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__736(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__735(rest, acc, stack, context, line, offset) do
    parse_datetime_us__734(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__736(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__730(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__730(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__737(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__737(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__738(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__738(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__739(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__689(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__740(rest, acc, stack, context, line, offset) do
    parse_datetime_us__741(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__741(rest, acc, stack, context, line, offset) do
    parse_datetime_us__742(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__742(rest, acc, stack, context, line, offset) do
    parse_datetime_us__748(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__744(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__745(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__744(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__739(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__745(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__739(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__745(rest, acc, stack, context, line, offset) do
    parse_datetime_us__746(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__746(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__743(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__747(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__744(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__748(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__749(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__748(rest, acc, stack, context, line, offset) do
    parse_datetime_us__747(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__749(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__743(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__743(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__750(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__750(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__751(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__751(rest, acc, stack, context, line, offset) do
    parse_datetime_us__755(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__753(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__752(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__754(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__753(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__755(rest, acc, stack, context, line, offset) do
    parse_datetime_us__756(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__756(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__757(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__756(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__757(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__756(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__757(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__756(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__757(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__756(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__757(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__756(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__754(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__757(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__758(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__758(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__752(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__752(rest, acc, stack, context, line, offset) do
    parse_datetime_us__759(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__759(rest, acc, stack, context, line, offset) do
    parse_datetime_us__760(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__760(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__760(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__760(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__760(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__760(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__760(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__760(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__760(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__760(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__760(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__760(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__760(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__760(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__761(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__760(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__739(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__761(rest, acc, stack, context, line, offset) do
    parse_datetime_us__762(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__762(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__763(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__762(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__763(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__763(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__764(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__764(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__765(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__765(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__766(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__766(rest, acc, stack, context, line, offset) do
    parse_datetime_us__770(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__768(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__767(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__769(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__768(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__770(rest, acc, stack, context, line, offset) do
    parse_datetime_us__771(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__771(
         <<",", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__772(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__771(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__772(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__771(
         <<"/", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__772(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__771(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__772(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__771(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__772(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__771(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__769(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__772(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__773(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__773(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__767(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__767(rest, acc, stack, context, line, offset) do
    parse_datetime_us__774(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__774(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__775(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__774(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__739(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__775(rest, acc, stack, context, line, offset) do
    parse_datetime_us__777(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime_us__777(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__778(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__777(rest, acc, stack, context, line, offset) do
    parse_datetime_us__776(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__776(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__779(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__778(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__779(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__778(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__777(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__779(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__780(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__780(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__398(rest, acc, stack, context, line, offset) do
    parse_datetime_us__781(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__781(rest, acc, stack, context, line, offset) do
    parse_datetime_us__785(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__783(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__782(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__784(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__783(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__785(
         <<"t", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__786(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__785(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__786(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__785(
         <<"+", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__786(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__785(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__786(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__785(rest, acc, stack, context, line, offset) do
    parse_datetime_us__784(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__786(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__782(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__782(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__787(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__787(rest, acc, stack, context, line, offset) do
    parse_datetime_us__805(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__789(rest, acc, stack, context, line, offset) do
    parse_datetime_us__790(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__790(rest, acc, stack, context, line, offset) do
    parse_datetime_us__791(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__791(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__791(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__792(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__791(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__792(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__792(rest, acc, stack, context, line, offset) do
    parse_datetime_us__793(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__793(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__794(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__794(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__795(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__795(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__796(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__795(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__796(rest, acc, stack, context, line, offset) do
    parse_datetime_us__797(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__797(rest, acc, stack, context, line, offset) do
    parse_datetime_us__798(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__798(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__798(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__799(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__798(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__799(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__799(rest, acc, stack, context, line, offset) do
    parse_datetime_us__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__800(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__801(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__801(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__802(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__802(<<":", _::binary>> = rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__396(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__802(rest, acc, stack, context, line, offset) do
    parse_datetime_us__803(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__803(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__788(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__804(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__789(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__805(rest, acc, stack, context, line, offset) do
    parse_datetime_us__806(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__806(rest, acc, stack, context, line, offset) do
    parse_datetime_us__807(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__807(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__807(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__808(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__807(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__808(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__808(rest, acc, stack, context, line, offset) do
    parse_datetime_us__809(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__809(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__810(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__810(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__811(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__811(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__812(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__811(rest, acc, stack, context, line, offset) do
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__812(rest, acc, stack, context, line, offset) do
    parse_datetime_us__813(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__813(rest, acc, stack, context, line, offset) do
    parse_datetime_us__814(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__814(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__814(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__815(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__814(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__815(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__815(rest, acc, stack, context, line, offset) do
    parse_datetime_us__816(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__816(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__817(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__817(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__818(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__818(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__819(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__818(rest, acc, stack, context, line, offset) do
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__819(rest, acc, stack, context, line, offset) do
    parse_datetime_us__820(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__820(rest, acc, stack, context, line, offset) do
    parse_datetime_us__821(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__821(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__821(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__822(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__821(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__822(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__804(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__822(rest, acc, stack, context, line, offset) do
    parse_datetime_us__823(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__823(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__824(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__824(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__825(
      rest,
      [
        second:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__825(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__826(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__825(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__826(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__826(rest, acc, stack, context, line, offset) do
    parse_datetime_us__830(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__828(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__827(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__829(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__828(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__830(rest, acc, stack, context, line, offset) do
    parse_datetime_us__831(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__831(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__832(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__831(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__829(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__832(rest, acc, stack, context, line, offset) do
    parse_datetime_us__834(rest, acc, [23 | stack], context, line, offset)
  end

  defp parse_datetime_us__834(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__835(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__834(rest, acc, stack, context, line, offset) do
    parse_datetime_us__833(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__833(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__836(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__835(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__836(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__835(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__834(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__836(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__837(
      rest,
      [microsecond: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__837(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__827(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__827(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__788(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__788(rest, acc, stack, context, line, offset) do
    parse_datetime_us__838(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__838(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__839(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__838(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__839(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__839(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__840(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__840(rest, acc, stack, context, line, offset) do
    parse_datetime_us__844(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__842(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__841(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__843(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__842(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__844(rest, acc, stack, context, line, offset) do
    parse_datetime_us__845(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__845(
         <<"am", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["am"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__845(
         <<"a.m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["a.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__845(
         <<"a.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["a.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__845(
         <<"a_m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["a_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__845(
         <<"pm", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["pm"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__845(
         <<"p.m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["p.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__845(
         <<"p.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["p.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__845(
         <<"p_m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["p_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__845(
         <<"a", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["a"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__845(
         <<"p", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__846(rest, ["p"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__845(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__843(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__846(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 === 116 or x0 === 109 or x0 === 97 or x0 === 115 or x0 === 100 or x0 === 101 or
              x0 === 111 or
              x0 === 108 or x0 === 107 do
    [acc | stack] = stack
    parse_datetime_us__843(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__846(rest, acc, stack, context, line, offset) do
    parse_datetime_us__847(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__847(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__848(
      rest,
      [
        am_pm:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__848(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__841(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__841(rest, acc, stack, context, line, offset) do
    parse_datetime_us__849(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__849(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__850(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__849(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__850(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__850(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__851(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__851(rest, acc, stack, context, line, offset) do
    parse_datetime_us__855(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__853(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__854(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__853(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__855(rest, acc, stack, context, line, offset) do
    parse_datetime_us__883(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__857(rest, acc, stack, context, line, offset) do
    parse_datetime_us__858(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__858(
         <<"utc", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["utc"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"gmt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["gmt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"z", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["z"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__858(
         <<"eastern", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["eastern"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__858(
         <<"est", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["est"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"edt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["edt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"et", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["et"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__858(
         <<"pacific", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["pacific"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__858(
         <<"pst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["pst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"pdt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["pdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"pt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["pt"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__858(
         <<"central", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["central"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__858(
         <<"cst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["cst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"cdt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["cdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"ct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["ct"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__858(
         <<"mountain", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(
      rest,
      ["mountain"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__858(
         <<"mst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["mst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"mdt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["mdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"mt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["mt"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__858(
         <<"alaska", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["alaska"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__858(
         <<"akst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["akst"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__858(
         <<"akdt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["akdt"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__858(
         <<"akt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["akt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"hawaii", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["hawaii"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__858(
         <<"hast", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["hast"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__858(
         <<"hadt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["hadt"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__858(
         <<"hat", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["hat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(
         <<"hst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__859(rest, ["hst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__858(rest, _acc, stack, context, line, offset) do
    [_, _, acc | stack] = stack
    parse_datetime_us__854(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__859(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__860(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__860(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__856(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__861(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__857(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__862(rest, acc, stack, context, line, offset) do
    parse_datetime_us__863(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__863(
         <<"+", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__864(rest, ["+"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__863(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__864(rest, ["-"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__863(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__861(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__864(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__865(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__864(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__861(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__865(rest, acc, stack, context, line, offset) do
    parse_datetime_us__867(rest, acc, [1 | stack], context, line, offset)
  end

  defp parse_datetime_us__867(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__868(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__867(rest, acc, stack, context, line, offset) do
    parse_datetime_us__866(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__866(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__869(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__868(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__869(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__868(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__867(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__869(rest, acc, stack, context, line, offset) do
    parse_datetime_us__870(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__870(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__871(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__870(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__871(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__871(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__872(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__872(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__873(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__872(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__873(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__873(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__874(
      rest,
      [utc_offset: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__874(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__856(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__875(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__862(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__876(rest, acc, stack, context, line, offset) do
    parse_datetime_us__877(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__877(rest, acc, stack, context, line, offset) do
    parse_datetime_us__878(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__878(
         <<"utc", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__879(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__878(
         <<"gmt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__879(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__878(
         <<"z", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__879(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__878(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__875(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__879(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__880(rest, ["UTC"] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__880(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__881(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__881(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__856(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__882(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__876(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__883(rest, acc, stack, context, line, offset) do
    parse_datetime_us__884(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__884(rest, acc, stack, context, line, offset) do
    parse_datetime_us__885(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__885(
         <<"utc", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__886(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__885(
         <<"gmt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__886(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__885(
         <<"z", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__886(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__885(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__882(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__886(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__887(rest, ["UTC"] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__887(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__888(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__888(rest, acc, stack, context, line, offset) do
    parse_datetime_us__889(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__889(
         <<"+", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__890(rest, ["+"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__889(
         <<"-", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__890(rest, ["-"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__889(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__882(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__890(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__891(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__890(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__882(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__891(rest, acc, stack, context, line, offset) do
    parse_datetime_us__893(rest, acc, [1 | stack], context, line, offset)
  end

  defp parse_datetime_us__893(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__894(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__893(rest, acc, stack, context, line, offset) do
    parse_datetime_us__892(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__892(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__895(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__894(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__895(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__894(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__893(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__895(rest, acc, stack, context, line, offset) do
    parse_datetime_us__896(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__896(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__897(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__896(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__897(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__897(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__898(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__898(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime_us__899(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__898(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__899(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__899(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__900(
      rest,
      [utc_offset: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__900(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__856(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__856(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__852(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__901(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__397(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__902(rest, acc, stack, context, line, offset) do
    parse_datetime_us__903(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__903(rest, acc, stack, context, line, offset) do
    parse_datetime_us__904(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__904(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(
      rest,
      ["september"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 9
    )
  end

  defp parse_datetime_us__904(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(
      rest,
      ["november"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__904(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(
      rest,
      ["february"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__904(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(
      rest,
      ["december"] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 8
    )
  end

  defp parse_datetime_us__904(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__904(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime_us__904(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime_us__904(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__904(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime_us__904(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__904(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__904(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__904(
         <<"sep", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"oct", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"nov", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"may", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"mar", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"jun", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"jul", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"jan", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"feb", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"dec", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"aug", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(
         <<"apr", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__905(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__904(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__905(rest, acc, stack, context, line, offset) do
    parse_datetime_us__906(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__906(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__907(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__906(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__907(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__907(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__908(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__908(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__909(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__909(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__910(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__910(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__911(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__910(rest, acc, stack, context, line, offset) do
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__911(rest, acc, stack, context, line, offset) do
    parse_datetime_us__912(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__912(rest, acc, stack, context, line, offset) do
    parse_datetime_us__913(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__913(rest, acc, stack, context, line, offset) do
    parse_datetime_us__919(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__915(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__916(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__915(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__916(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__916(rest, acc, stack, context, line, offset) do
    parse_datetime_us__917(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__917(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__914(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__918(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__915(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__919(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__920(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__919(rest, acc, stack, context, line, offset) do
    parse_datetime_us__918(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__920(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__914(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__914(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__921(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__921(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__922(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__922(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__923(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__922(rest, acc, stack, context, line, offset) do
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__923(rest, acc, stack, context, line, offset) do
    parse_datetime_us__941(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__925(rest, acc, stack, context, line, offset) do
    parse_datetime_us__926(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__926(rest, acc, stack, context, line, offset) do
    parse_datetime_us__927(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__927(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__927(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__928(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__927(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__928(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__928(rest, acc, stack, context, line, offset) do
    parse_datetime_us__929(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__929(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__930(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__930(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__931(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__931(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__932(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__931(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__932(rest, acc, stack, context, line, offset) do
    parse_datetime_us__933(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__933(rest, acc, stack, context, line, offset) do
    parse_datetime_us__934(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__934(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__934(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__935(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__934(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__935(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__935(rest, acc, stack, context, line, offset) do
    parse_datetime_us__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__936(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__937(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__937(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__938(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__938(<<":", _::binary>> = rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__938(rest, acc, stack, context, line, offset) do
    parse_datetime_us__939(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__939(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__924(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__940(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__925(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__941(rest, acc, stack, context, line, offset) do
    parse_datetime_us__942(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__942(rest, acc, stack, context, line, offset) do
    parse_datetime_us__943(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__943(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__943(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__944(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__943(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__944(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__944(rest, acc, stack, context, line, offset) do
    parse_datetime_us__945(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__945(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__946(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__946(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__947(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__947(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__948(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__947(rest, acc, stack, context, line, offset) do
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__948(rest, acc, stack, context, line, offset) do
    parse_datetime_us__949(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__949(rest, acc, stack, context, line, offset) do
    parse_datetime_us__950(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__950(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__950(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__951(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__950(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__951(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__951(rest, acc, stack, context, line, offset) do
    parse_datetime_us__952(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__952(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__953(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__953(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__954(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__954(
         <<":", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__955(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__954(rest, acc, stack, context, line, offset) do
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__955(rest, acc, stack, context, line, offset) do
    parse_datetime_us__956(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__956(rest, acc, stack, context, line, offset) do
    parse_datetime_us__957(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__957(
         <<"00", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"01", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"02", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"03", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"04", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"05", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"06", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"07", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"08", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"09", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"59", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"58", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"57", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"56", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"55", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"54", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"53", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"52", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"51", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"50", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"49", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"48", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"47", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"46", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"45", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"44", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"43", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"42", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"41", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"40", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"39", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"38", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"37", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"36", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"35", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"34", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"33", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"32", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"31", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"30", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"29", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"28", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"27", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"26", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"25", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"24", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"23", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"22", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"21", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"20", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"19", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"18", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"17", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"16", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"15", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"14", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"13", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"12", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"11", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"10", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__957(
         <<"9", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"8", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"7", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"6", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"5", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"4", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"3", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"2", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"1", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(
         <<"0", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__958(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__957(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__958(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime_us__940(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__958(rest, acc, stack, context, line, offset) do
    parse_datetime_us__959(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__959(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__960(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__960(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__961(
      rest,
      [
        second:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__961(
         <<".", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__962(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__961(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__962(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__962(rest, acc, stack, context, line, offset) do
    parse_datetime_us__966(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__964(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__963(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__965(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__964(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__966(rest, acc, stack, context, line, offset) do
    parse_datetime_us__967(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__967(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__968(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__967(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__965(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__968(rest, acc, stack, context, line, offset) do
    parse_datetime_us__970(rest, acc, [23 | stack], context, line, offset)
  end

  defp parse_datetime_us__970(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime_us__971(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__970(rest, acc, stack, context, line, offset) do
    parse_datetime_us__969(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__969(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime_us__972(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__971(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime_us__972(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__971(rest, acc, [count | stack], context, line, offset) do
    parse_datetime_us__970(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime_us__972(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__973(
      rest,
      [microsecond: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__973(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__963(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__963(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__924(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__924(rest, acc, stack, context, line, offset) do
    parse_datetime_us__974(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__974(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__975(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__974(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__975(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__975(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__976(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__976(rest, acc, stack, context, line, offset) do
    parse_datetime_us__980(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__978(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__977(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__979(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime_us__978(rest, [], stack, context, line, offset)
  end

  defp parse_datetime_us__980(rest, acc, stack, context, line, offset) do
    parse_datetime_us__981(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__981(
         <<"am", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["am"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__981(
         <<"a.m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["a.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__981(
         <<"a.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["a.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__981(
         <<"a_m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["a_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__981(
         <<"pm", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["pm"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime_us__981(
         <<"p.m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["p.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__981(
         <<"p.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["p.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime_us__981(
         <<"p_m", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["p_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime_us__981(
         <<"a", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["a"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__981(
         <<"p", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__982(rest, ["p"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__981(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime_us__979(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__982(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 === 116 or x0 === 109 or x0 === 97 or x0 === 115 or x0 === 100 or x0 === 101 or
              x0 === 111 or
              x0 === 108 or x0 === 107 do
    [acc | stack] = stack
    parse_datetime_us__979(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__982(rest, acc, stack, context, line, offset) do
    parse_datetime_us__983(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__983(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime_us__984(
      rest,
      [
        am_pm:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime_us__984(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__977(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__977(rest, acc, stack, context, line, offset) do
    parse_datetime_us__985(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime_us__985(
         <<" ", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime_us__986(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime_us__985(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime_us__986(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime_us__986(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime_us__987(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime_us__987(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime_us__988(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime_us__987(rest, acc, stack, context, line, offset) do
    parse_datetime_us__901(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime_us__988(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime_us__11(rest, acc, _stack, context, line, offset) do
    {:ok, acc, rest, context, line, offset}
  end

  @doc """
  Parses the given `binary` as parse_datetime.

  Returns `{:ok, [token], rest, context, position, byte_offset}` or
  `{:error, reason, rest, context, line, byte_offset}` where `position`
  describes the location of the parse_datetime (start position) as `{line, offset_to_start_of_line}`.

  To column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.

  ## Options

    * `:byte_offset` - the byte offset for the whole binary, defaults to 0
    * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`
    * `:context` - the initial context value. It will be converted to a map

  """
  @spec parse_datetime(binary, keyword) ::
          {:ok, [term], rest, context, line, byte_offset}
          | {:error, reason, rest, context, line, byte_offset}
        when line: {pos_integer, byte_offset},
             byte_offset: pos_integer,
             rest: binary,
             reason: String.t(),
             context: map
  def parse_datetime(binary, opts \\ []) when is_binary(binary) do
    context = Map.new(Keyword.get(opts, :context, []))
    byte_offset = Keyword.get(opts, :byte_offset, 0)

    line =
      case Keyword.get(opts, :line, 1) do
        {_, _} = line -> line
        line -> {line, byte_offset}
      end

    case parse_datetime__0(binary, [], [], context, line, byte_offset) do
      {:ok, acc, rest, context, line, offset} ->
        {:ok, :lists.reverse(acc), rest, context, line, offset}

      {:error, _, _, _, _, _} = error ->
        error
    end
  end

  defp parse_datetime__0(rest, acc, stack, context, line, offset) do
    parse_datetime__4(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__2(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__3(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__2(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__4(rest, acc, stack, context, line, offset) do
    parse_datetime__5(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__5(
         <<"wednesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["wednesday"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__5(
         <<"thursday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["thursday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__5(
         <<"saturday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["saturday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__5(
         <<"tuesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["tuesday"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__5(
         <<"sunday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["sunday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__5(
         <<"monday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["monday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__5(
         <<"friday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__6(rest, ["friday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__5(<<"thurs", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["thurs"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__5(<<"tues", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["tues"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__5(<<"thur", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["thur"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__5(<<"wed", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["wed"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"tue", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["tue"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"thu", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["thu"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"sun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["sun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"sat", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["sat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"mon", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["mon"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(<<"fri", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__6(rest, ["fri"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__5(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__3(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__6(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__7(
      rest,
      [
        vocal_day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__7(rest, acc, stack, context, line, offset) do
    parse_datetime__8(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__8(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__9(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__8(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__9(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__9(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__10(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__10(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__1(rest, acc, stack, context, line, offset) do
    parse_datetime__898(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__12(rest, acc, stack, context, line, offset) do
    parse_datetime__351(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__14(rest, acc, stack, context, line, offset) do
    parse_datetime__15(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__15(rest, acc, stack, context, line, offset) do
    parse_datetime__16(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__16(rest, acc, stack, context, line, offset) do
    parse_datetime__22(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__18(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__19(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__18(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric day from 01-31 while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime__19(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    {:error,
     "did not expect numeric day from 01-31 while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime__19(rest, acc, stack, context, line, offset) do
    parse_datetime__20(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__20(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__17(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__21(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__18(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__22(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__23(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__22(rest, acc, stack, context, line, offset) do
    parse_datetime__21(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__23(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__17(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__17(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__24(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__24(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__25(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__25(rest, acc, stack, context, line, offset) do
    parse_datetime__29(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__27(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__26(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__28(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__27(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__29(rest, acc, stack, context, line, offset) do
    parse_datetime__30(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__30(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__30(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__30(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__30(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__30(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__31(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__30(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__28(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__31(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__32(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__32(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__26(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__26(rest, acc, stack, context, line, offset) do
    parse_datetime__44(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__34(rest, acc, stack, context, line, offset) do
    parse_datetime__35(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__35(rest, acc, stack, context, line, offset) do
    parse_datetime__36(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__36(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__36(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__36(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__36(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__36(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__36(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__36(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__36(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__36(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__37(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__36(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__36(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__36(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__36(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__37(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__36(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected word month either fully spelled or 3-letter abbreviation while processing word month either fully spelled or 3-letter abbreviation, followed by string \" \", followed by numeric day from 01-31, followed by string \" \", followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing, followed by string \" \" or nothing, followed by 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \"t\" or string \"-\" or string \"+\" or string \" \" or nothing, followed by numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by string \" \" or nothing, followed by am or pm or nothing or nothing, followed by string \" \" or nothing, followed by timezone with offset, followed by offset with +/- and 4 digits or timezone with offset or offset with +/- and 4 digits or timezone abbreviation or nothing or numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_datetime__37(rest, acc, stack, context, line, offset) do
    parse_datetime__38(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__38(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__39(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__38(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__39(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__39(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__40(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__40(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__41(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__41(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__42(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__42(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__33(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__43(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__34(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__44(rest, acc, stack, context, line, offset) do
    parse_datetime__45(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__45(rest, acc, stack, context, line, offset) do
    parse_datetime__46(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__46(rest, acc, stack, context, line, offset) do
    parse_datetime__52(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__48(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__49(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__48(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__43(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__49(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__43(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__49(rest, acc, stack, context, line, offset) do
    parse_datetime__50(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__50(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__47(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__51(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__48(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__52(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__53(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__52(rest, acc, stack, context, line, offset) do
    parse_datetime__51(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__53(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__47(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__47(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__54(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__54(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__55(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__55(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__33(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__33(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__56(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__14(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__57(rest, acc, stack, context, line, offset) do
    parse_datetime__69(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__59(rest, acc, stack, context, line, offset) do
    parse_datetime__60(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__60(rest, acc, stack, context, line, offset) do
    parse_datetime__61(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__61(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__61(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__61(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__61(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__61(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__61(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__61(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__61(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__61(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__62(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__61(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__61(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__61(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__61(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__62(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__61(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__62(rest, acc, stack, context, line, offset) do
    parse_datetime__63(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__63(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__64(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__63(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__64(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__64(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__65(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__65(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__66(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__66(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__67(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__67(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__58(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__68(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__59(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__69(rest, acc, stack, context, line, offset) do
    parse_datetime__70(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__70(rest, acc, stack, context, line, offset) do
    parse_datetime__71(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__71(rest, acc, stack, context, line, offset) do
    parse_datetime__77(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__73(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__74(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__73(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__68(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__74(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__68(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__74(rest, acc, stack, context, line, offset) do
    parse_datetime__75(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__75(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__72(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__76(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__73(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__77(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__78(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__77(rest, acc, stack, context, line, offset) do
    parse_datetime__76(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__78(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__72(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__72(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__79(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__79(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__80(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__80(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__58(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__58(rest, acc, stack, context, line, offset) do
    parse_datetime__84(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__82(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__81(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__83(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__82(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__84(rest, acc, stack, context, line, offset) do
    parse_datetime__85(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__85(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__85(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__85(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__85(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__85(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__86(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__85(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__83(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__86(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__87(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__87(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__81(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__81(rest, acc, stack, context, line, offset) do
    parse_datetime__88(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__88(rest, acc, stack, context, line, offset) do
    parse_datetime__89(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__89(rest, acc, stack, context, line, offset) do
    parse_datetime__95(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__91(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__92(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__91(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__92(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__56(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__92(rest, acc, stack, context, line, offset) do
    parse_datetime__93(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__93(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__90(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__94(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__91(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__95(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__96(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__95(rest, acc, stack, context, line, offset) do
    parse_datetime__94(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__96(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__90(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__90(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__97(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__97(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__98(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__98(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__99(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__57(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__100(rest, acc, stack, context, line, offset) do
    parse_datetime__112(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__102(rest, acc, stack, context, line, offset) do
    parse_datetime__103(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__103(rest, acc, stack, context, line, offset) do
    parse_datetime__104(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__104(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__104(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__104(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__104(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__104(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__104(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__104(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__104(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__104(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__104(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__104(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__104(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__105(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__104(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__105(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__104(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__105(rest, acc, stack, context, line, offset) do
    parse_datetime__106(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__106(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__107(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__106(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__107(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__107(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__108(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__108(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__109(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__109(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__110(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__110(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__101(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__111(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__102(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__112(rest, acc, stack, context, line, offset) do
    parse_datetime__113(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__113(rest, acc, stack, context, line, offset) do
    parse_datetime__114(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__114(rest, acc, stack, context, line, offset) do
    parse_datetime__120(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__116(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__117(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__116(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__111(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__117(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__111(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__117(rest, acc, stack, context, line, offset) do
    parse_datetime__118(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__118(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__115(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__119(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__116(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__120(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__121(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__120(rest, acc, stack, context, line, offset) do
    parse_datetime__119(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__121(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__115(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__115(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__122(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__122(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__123(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__123(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__101(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__101(rest, acc, stack, context, line, offset) do
    parse_datetime__127(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__125(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__124(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__126(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__125(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__127(rest, acc, stack, context, line, offset) do
    parse_datetime__128(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__128(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__129(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__128(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__129(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__128(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__129(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__128(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__129(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__128(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__129(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__128(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__126(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__129(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__130(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__130(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__124(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__124(rest, acc, stack, context, line, offset) do
    parse_datetime__131(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__131(rest, acc, stack, context, line, offset) do
    parse_datetime__132(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__132(rest, acc, stack, context, line, offset) do
    parse_datetime__138(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__134(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__135(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__134(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__135(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__135(rest, acc, stack, context, line, offset) do
    parse_datetime__136(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__136(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__133(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__137(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__134(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__138(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__139(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__138(rest, acc, stack, context, line, offset) do
    parse_datetime__137(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__139(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__133(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__133(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__140(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__140(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__141(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__141(rest, acc, stack, context, line, offset) do
    parse_datetime__145(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__143(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__142(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__144(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__143(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__145(rest, acc, stack, context, line, offset) do
    parse_datetime__146(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__146(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__147(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__146(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__147(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__146(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__147(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__146(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__147(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__146(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__147(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__146(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__144(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__147(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__148(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__148(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__142(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__142(rest, acc, stack, context, line, offset) do
    parse_datetime__149(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__149(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__150(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__149(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__99(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__150(rest, acc, stack, context, line, offset) do
    parse_datetime__152(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__152(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__153(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__152(rest, acc, stack, context, line, offset) do
    parse_datetime__151(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__151(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__154(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__153(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__154(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__153(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__152(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__154(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__155(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__155(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__156(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__100(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__157(rest, acc, stack, context, line, offset) do
    parse_datetime__169(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__159(rest, acc, stack, context, line, offset) do
    parse_datetime__160(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__160(rest, acc, stack, context, line, offset) do
    parse_datetime__161(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__161(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__161(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__161(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__161(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__161(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__161(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__161(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__161(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__161(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__161(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__161(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__161(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__162(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__161(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__162(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__161(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__156(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__162(rest, acc, stack, context, line, offset) do
    parse_datetime__163(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__163(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__164(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__163(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__164(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__164(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__165(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__165(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__166(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__166(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__167(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__167(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__158(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__168(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__159(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__169(rest, acc, stack, context, line, offset) do
    parse_datetime__170(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__170(rest, acc, stack, context, line, offset) do
    parse_datetime__171(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__171(rest, acc, stack, context, line, offset) do
    parse_datetime__177(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__173(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__174(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__173(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__168(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__174(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__168(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__174(rest, acc, stack, context, line, offset) do
    parse_datetime__175(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__175(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__172(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__176(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__173(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__177(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__178(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__177(rest, acc, stack, context, line, offset) do
    parse_datetime__176(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__178(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__172(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__172(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__179(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__179(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__180(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__180(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__158(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__158(rest, acc, stack, context, line, offset) do
    parse_datetime__184(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__182(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__181(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__183(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__182(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__184(rest, acc, stack, context, line, offset) do
    parse_datetime__185(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__185(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__186(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__185(<<", ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__186(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__185(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__183(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__186(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__187(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__187(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__181(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__181(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime__188(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime__181(rest, acc, stack, context, line, offset) do
    parse_datetime__156(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__188(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__189(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__157(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__190(rest, acc, stack, context, line, offset) do
    parse_datetime__191(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__191(rest, acc, stack, context, line, offset) do
    parse_datetime__192(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__192(rest, acc, stack, context, line, offset) do
    parse_datetime__198(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__194(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__195(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__194(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__195(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__195(rest, acc, stack, context, line, offset) do
    parse_datetime__196(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__196(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__193(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__197(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__194(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__198(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__199(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__198(rest, acc, stack, context, line, offset) do
    parse_datetime__197(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__199(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__193(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__193(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__200(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__200(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__201(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__201(rest, acc, stack, context, line, offset) do
    parse_datetime__205(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__203(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__202(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__204(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__203(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__205(rest, acc, stack, context, line, offset) do
    parse_datetime__206(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__206(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__206(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__206(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__206(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__206(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__207(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__206(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__204(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__207(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__208(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__208(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__202(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__202(rest, acc, stack, context, line, offset) do
    parse_datetime__220(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__210(rest, acc, stack, context, line, offset) do
    parse_datetime__211(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__211(rest, acc, stack, context, line, offset) do
    parse_datetime__212(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__212(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__212(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__212(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__212(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__212(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__212(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__212(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__212(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__212(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__212(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__212(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__212(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__213(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__212(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__213(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__212(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__213(rest, acc, stack, context, line, offset) do
    parse_datetime__214(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__214(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__215(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__214(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__215(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__215(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__216(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__216(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__217(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__217(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__218(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__218(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__209(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__219(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__210(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__220(rest, acc, stack, context, line, offset) do
    parse_datetime__221(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__221(rest, acc, stack, context, line, offset) do
    parse_datetime__222(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__222(rest, acc, stack, context, line, offset) do
    parse_datetime__228(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__224(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__225(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__224(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__219(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__225(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__219(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__225(rest, acc, stack, context, line, offset) do
    parse_datetime__226(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__226(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__223(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__227(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__224(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__228(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__229(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__228(rest, acc, stack, context, line, offset) do
    parse_datetime__227(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__229(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__223(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__223(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__230(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__230(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__231(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__231(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__209(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__209(rest, acc, stack, context, line, offset) do
    parse_datetime__235(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__233(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__232(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__234(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__233(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__235(rest, acc, stack, context, line, offset) do
    parse_datetime__236(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__236(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__236(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__236(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__236(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__236(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__237(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__236(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__234(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__237(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__238(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__238(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__232(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__232(rest, acc, stack, context, line, offset) do
    parse_datetime__239(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__239(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__240(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__239(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__189(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__240(rest, acc, stack, context, line, offset) do
    parse_datetime__242(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__242(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__243(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__242(rest, acc, stack, context, line, offset) do
    parse_datetime__241(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__241(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__244(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__243(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__244(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__243(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__242(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__244(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__245(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__245(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__246(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__190(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__247(rest, acc, stack, context, line, offset) do
    parse_datetime__248(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__248(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__249(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__248(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__249(rest, acc, stack, context, line, offset) do
    parse_datetime__251(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__251(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__252(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__251(rest, acc, stack, context, line, offset) do
    parse_datetime__250(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__250(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__253(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__252(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__253(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__252(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__251(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__253(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__254(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__254(rest, acc, stack, context, line, offset) do
    parse_datetime__258(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__256(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__255(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__257(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__256(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__258(rest, acc, stack, context, line, offset) do
    parse_datetime__259(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__259(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__260(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__259(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__260(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__259(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__260(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__259(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__260(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__259(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__260(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__259(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__257(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__260(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__261(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__261(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__255(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__255(rest, acc, stack, context, line, offset) do
    parse_datetime__273(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__263(rest, acc, stack, context, line, offset) do
    parse_datetime__264(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__264(rest, acc, stack, context, line, offset) do
    parse_datetime__265(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__265(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__265(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__265(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__265(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__265(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__265(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__265(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__265(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__265(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__265(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__265(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__265(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__266(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__265(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__266(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__265(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__266(rest, acc, stack, context, line, offset) do
    parse_datetime__267(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__267(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__268(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__267(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__268(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__268(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__269(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__269(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__270(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__270(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__271(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__271(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__262(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__272(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__263(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__273(rest, acc, stack, context, line, offset) do
    parse_datetime__274(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__274(rest, acc, stack, context, line, offset) do
    parse_datetime__275(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__275(rest, acc, stack, context, line, offset) do
    parse_datetime__281(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__277(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__278(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__277(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__272(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__278(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__272(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__278(rest, acc, stack, context, line, offset) do
    parse_datetime__279(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__279(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__276(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__280(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__277(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__281(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__282(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__281(rest, acc, stack, context, line, offset) do
    parse_datetime__280(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__282(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__276(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__276(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__283(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__283(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__284(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__284(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__262(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__262(rest, acc, stack, context, line, offset) do
    parse_datetime__288(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__286(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__285(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__287(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__286(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__288(rest, acc, stack, context, line, offset) do
    parse_datetime__289(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__289(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__290(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__289(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__290(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__289(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__290(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__289(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__290(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__289(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__290(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__289(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__287(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__290(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__291(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__291(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__285(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__285(rest, acc, stack, context, line, offset) do
    parse_datetime__292(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__292(rest, acc, stack, context, line, offset) do
    parse_datetime__293(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__293(rest, acc, stack, context, line, offset) do
    parse_datetime__299(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__295(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__296(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__295(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__296(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__246(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__296(rest, acc, stack, context, line, offset) do
    parse_datetime__297(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__297(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__294(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__298(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__295(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__299(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__300(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__299(rest, acc, stack, context, line, offset) do
    parse_datetime__298(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__300(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__294(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__294(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__301(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__301(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__302(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__302(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__303(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__247(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__304(rest, acc, stack, context, line, offset) do
    parse_datetime__305(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__305(rest, acc, stack, context, line, offset) do
    parse_datetime__306(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__306(rest, acc, stack, context, line, offset) do
    parse_datetime__312(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__308(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__309(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__308(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__309(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__309(rest, acc, stack, context, line, offset) do
    parse_datetime__310(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__310(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__307(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__311(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__308(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__312(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__313(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__312(rest, acc, stack, context, line, offset) do
    parse_datetime__311(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__313(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__307(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__307(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__314(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__314(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__315(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__315(rest, acc, stack, context, line, offset) do
    parse_datetime__319(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__317(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__316(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__318(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__317(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__319(rest, acc, stack, context, line, offset) do
    parse_datetime__320(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__320(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__321(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__320(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__321(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__320(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__321(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__320(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__321(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__320(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__321(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__320(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__318(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__321(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__322(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__322(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__316(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__316(rest, acc, stack, context, line, offset) do
    parse_datetime__334(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__324(rest, acc, stack, context, line, offset) do
    parse_datetime__325(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__325(rest, acc, stack, context, line, offset) do
    parse_datetime__326(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__326(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__326(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__326(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__326(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__326(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__326(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__326(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__326(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__326(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__326(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__326(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__326(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__327(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__326(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__327(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__326(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__327(rest, acc, stack, context, line, offset) do
    parse_datetime__328(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__328(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__329(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__328(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__329(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__329(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__330(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__330(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__331(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__331(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__332(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__332(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__323(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__333(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__324(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__334(rest, acc, stack, context, line, offset) do
    parse_datetime__335(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__335(rest, acc, stack, context, line, offset) do
    parse_datetime__336(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__336(rest, acc, stack, context, line, offset) do
    parse_datetime__342(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__338(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__339(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__338(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__333(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__339(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__333(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__339(rest, acc, stack, context, line, offset) do
    parse_datetime__340(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__340(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__337(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__341(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__338(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__342(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__343(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__342(rest, acc, stack, context, line, offset) do
    parse_datetime__341(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__343(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__337(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__337(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__344(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__344(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__345(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__345(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__323(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__323(rest, acc, stack, context, line, offset) do
    parse_datetime__346(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__346(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__347(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__346(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__347(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__346(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__347(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__346(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__347(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__346(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__347(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__346(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__347(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__348(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__348(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime__349(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime__348(rest, acc, stack, context, line, offset) do
    parse_datetime__303(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__349(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__350(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__304(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__351(rest, acc, stack, context, line, offset) do
    parse_datetime__352(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__352(rest, acc, stack, context, line, offset) do
    parse_datetime__353(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__353(rest, acc, stack, context, line, offset) do
    parse_datetime__359(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__355(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__356(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__355(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__350(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__356(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__350(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__356(rest, acc, stack, context, line, offset) do
    parse_datetime__357(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__357(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__354(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__358(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__355(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__359(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__360(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__359(rest, acc, stack, context, line, offset) do
    parse_datetime__358(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__360(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__354(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__354(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__361(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__361(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__362(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__362(rest, acc, stack, context, line, offset) do
    parse_datetime__366(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__364(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__363(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__365(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__364(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__366(rest, acc, stack, context, line, offset) do
    parse_datetime__367(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__367(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__368(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__367(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__368(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__367(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__368(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__367(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__368(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__367(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__368(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__367(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__365(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__368(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__369(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__369(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__363(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__363(rest, acc, stack, context, line, offset) do
    parse_datetime__370(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__370(rest, acc, stack, context, line, offset) do
    parse_datetime__371(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__371(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__371(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__371(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__371(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__371(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__371(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__371(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__371(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__371(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__371(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__371(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__371(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__372(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__371(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__372(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__371(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__350(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__372(rest, acc, stack, context, line, offset) do
    parse_datetime__373(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__373(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__374(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__373(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__374(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__374(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__375(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__375(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__376(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__376(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__377(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__377(rest, acc, stack, context, line, offset) do
    parse_datetime__381(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__379(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__378(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__380(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__379(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__381(rest, acc, stack, context, line, offset) do
    parse_datetime__382(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__382(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__383(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__382(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__383(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__382(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__383(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__382(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__383(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__382(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__383(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__382(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__380(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__383(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__384(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__384(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__378(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__378(rest, acc, stack, context, line, offset) do
    parse_datetime__385(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__385(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__386(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__385(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__350(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__386(rest, acc, stack, context, line, offset) do
    parse_datetime__388(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__388(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__389(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__388(rest, acc, stack, context, line, offset) do
    parse_datetime__387(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__387(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__390(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__389(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__390(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__389(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__388(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__390(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__391(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__391(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__13(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__13(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__392(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__12(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__393(rest, acc, stack, context, line, offset) do
    parse_datetime__732(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__395(rest, acc, stack, context, line, offset) do
    parse_datetime__396(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__396(rest, acc, stack, context, line, offset) do
    parse_datetime__397(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__397(rest, acc, stack, context, line, offset) do
    parse_datetime__403(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__399(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__400(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__399(rest, _acc, stack, context, line, offset) do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime__392(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__400(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime__392(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__400(rest, acc, stack, context, line, offset) do
    parse_datetime__401(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__401(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__402(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__399(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__403(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__404(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__403(rest, acc, stack, context, line, offset) do
    parse_datetime__402(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__404(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__398(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__398(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__405(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__405(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__406(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__406(rest, acc, stack, context, line, offset) do
    parse_datetime__410(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__408(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__407(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__409(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__408(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__410(rest, acc, stack, context, line, offset) do
    parse_datetime__411(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__411(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__412(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__411(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__412(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__411(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__412(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__411(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__412(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__411(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__412(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__411(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__409(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__412(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__413(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__413(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__407(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__407(rest, acc, stack, context, line, offset) do
    parse_datetime__425(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__415(rest, acc, stack, context, line, offset) do
    parse_datetime__416(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__416(rest, acc, stack, context, line, offset) do
    parse_datetime__417(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__417(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__417(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__417(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__417(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__417(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__417(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__417(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__417(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__417(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__417(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__417(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__417(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__418(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__417(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__418(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__417(rest, _acc, stack, context, line, offset) do
    [_, _, _, _, _, acc | stack] = stack
    parse_datetime__392(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__418(rest, acc, stack, context, line, offset) do
    parse_datetime__419(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__419(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__420(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__419(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__420(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__420(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__421(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__421(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__422(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__422(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__423(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__423(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__414(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__424(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__415(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__425(rest, acc, stack, context, line, offset) do
    parse_datetime__426(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__426(rest, acc, stack, context, line, offset) do
    parse_datetime__427(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__427(rest, acc, stack, context, line, offset) do
    parse_datetime__433(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__429(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__430(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__429(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__424(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__430(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__424(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__430(rest, acc, stack, context, line, offset) do
    parse_datetime__431(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__431(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__428(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__432(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__429(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__433(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__434(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__433(rest, acc, stack, context, line, offset) do
    parse_datetime__432(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__434(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__428(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__428(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__435(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__435(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__436(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__436(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__414(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__414(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__437(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__395(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__438(rest, acc, stack, context, line, offset) do
    parse_datetime__450(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__440(rest, acc, stack, context, line, offset) do
    parse_datetime__441(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__441(rest, acc, stack, context, line, offset) do
    parse_datetime__442(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__442(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__442(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__442(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__442(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__442(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__442(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__442(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__442(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__442(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__442(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__442(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__442(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__443(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__442(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__443(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__442(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__437(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__443(rest, acc, stack, context, line, offset) do
    parse_datetime__444(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__444(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__445(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__444(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__445(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__445(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__446(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__446(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__447(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__447(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__448(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__448(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__439(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__449(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__440(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__450(rest, acc, stack, context, line, offset) do
    parse_datetime__451(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__451(rest, acc, stack, context, line, offset) do
    parse_datetime__452(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__452(rest, acc, stack, context, line, offset) do
    parse_datetime__458(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__454(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__455(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__454(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__449(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__455(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__449(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__455(rest, acc, stack, context, line, offset) do
    parse_datetime__456(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__456(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__453(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__457(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__454(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__458(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__459(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__458(rest, acc, stack, context, line, offset) do
    parse_datetime__457(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__459(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__453(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__453(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__460(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__460(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__461(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__461(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__439(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__439(rest, acc, stack, context, line, offset) do
    parse_datetime__465(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__463(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__462(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__464(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__463(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__465(rest, acc, stack, context, line, offset) do
    parse_datetime__466(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__466(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__467(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__466(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__467(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__466(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__467(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__466(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__467(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__466(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__467(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__466(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__464(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__467(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__468(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__468(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__462(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__462(rest, acc, stack, context, line, offset) do
    parse_datetime__469(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__469(rest, acc, stack, context, line, offset) do
    parse_datetime__470(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__470(rest, acc, stack, context, line, offset) do
    parse_datetime__476(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__472(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__473(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__472(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__437(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__473(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__437(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__473(rest, acc, stack, context, line, offset) do
    parse_datetime__474(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__474(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__471(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__475(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__472(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__476(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__477(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__476(rest, acc, stack, context, line, offset) do
    parse_datetime__475(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__477(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__471(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__471(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__478(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__478(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__479(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__479(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__480(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__438(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__481(rest, acc, stack, context, line, offset) do
    parse_datetime__493(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__483(rest, acc, stack, context, line, offset) do
    parse_datetime__484(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__484(rest, acc, stack, context, line, offset) do
    parse_datetime__485(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__485(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__485(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__485(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__485(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__485(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__485(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__485(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__485(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__485(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__485(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__485(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__485(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__486(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__485(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__486(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__485(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__480(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__486(rest, acc, stack, context, line, offset) do
    parse_datetime__487(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__487(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__488(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__487(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__488(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__488(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__489(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__489(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__490(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__490(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__491(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__491(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__482(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__492(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__483(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__493(rest, acc, stack, context, line, offset) do
    parse_datetime__494(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__494(rest, acc, stack, context, line, offset) do
    parse_datetime__495(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__495(rest, acc, stack, context, line, offset) do
    parse_datetime__501(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__497(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__498(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__497(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__492(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__498(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__492(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__498(rest, acc, stack, context, line, offset) do
    parse_datetime__499(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__499(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__496(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__500(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__497(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__501(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__502(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__501(rest, acc, stack, context, line, offset) do
    parse_datetime__500(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__502(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__496(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__496(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__503(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__503(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__504(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__504(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__482(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__482(rest, acc, stack, context, line, offset) do
    parse_datetime__508(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__506(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__505(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__507(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__506(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__508(rest, acc, stack, context, line, offset) do
    parse_datetime__509(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__509(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__510(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__509(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__510(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__509(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__510(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__509(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__510(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__509(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__510(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__509(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__507(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__510(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__511(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__511(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__505(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__505(rest, acc, stack, context, line, offset) do
    parse_datetime__512(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__512(rest, acc, stack, context, line, offset) do
    parse_datetime__513(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__513(rest, acc, stack, context, line, offset) do
    parse_datetime__519(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__515(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__516(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__515(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__480(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__516(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__480(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__516(rest, acc, stack, context, line, offset) do
    parse_datetime__517(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__517(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__514(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__518(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__515(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__519(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__520(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__519(rest, acc, stack, context, line, offset) do
    parse_datetime__518(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__520(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__514(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__514(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__521(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__521(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__522(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__522(rest, acc, stack, context, line, offset) do
    parse_datetime__526(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__524(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__523(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__525(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__524(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__526(rest, acc, stack, context, line, offset) do
    parse_datetime__527(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__527(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__527(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__527(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__527(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__527(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__528(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__527(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__525(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__528(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__529(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__529(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__523(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__523(rest, acc, stack, context, line, offset) do
    parse_datetime__530(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__530(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__531(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__530(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__480(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__531(rest, acc, stack, context, line, offset) do
    parse_datetime__533(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__533(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__534(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__533(rest, acc, stack, context, line, offset) do
    parse_datetime__532(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__532(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__535(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__534(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__535(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__534(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__533(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__535(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__536(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__536(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__537(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__481(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__538(rest, acc, stack, context, line, offset) do
    parse_datetime__550(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__540(rest, acc, stack, context, line, offset) do
    parse_datetime__541(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__541(rest, acc, stack, context, line, offset) do
    parse_datetime__542(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__542(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__542(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__542(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__542(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__542(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__542(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__542(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__542(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__542(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__542(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__542(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__542(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__543(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__542(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__543(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__542(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__537(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__543(rest, acc, stack, context, line, offset) do
    parse_datetime__544(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__544(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__545(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__544(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__545(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__545(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__546(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__546(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__547(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__547(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__548(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__548(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__539(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__549(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__540(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__550(rest, acc, stack, context, line, offset) do
    parse_datetime__551(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__551(rest, acc, stack, context, line, offset) do
    parse_datetime__552(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__552(rest, acc, stack, context, line, offset) do
    parse_datetime__558(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__554(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__555(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__554(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__549(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__555(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__549(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__555(rest, acc, stack, context, line, offset) do
    parse_datetime__556(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__556(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__553(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__557(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__554(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__558(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__559(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__558(rest, acc, stack, context, line, offset) do
    parse_datetime__557(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__559(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__553(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__553(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__560(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__560(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__561(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__561(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__539(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__539(rest, acc, stack, context, line, offset) do
    parse_datetime__565(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__563(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__562(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__564(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__563(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__565(rest, acc, stack, context, line, offset) do
    parse_datetime__566(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__566(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__567(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__566(<<", ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__567(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__566(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__564(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__567(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__568(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__568(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__562(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__562(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime__569(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime__562(rest, acc, stack, context, line, offset) do
    parse_datetime__537(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__569(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__570(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__538(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__571(rest, acc, stack, context, line, offset) do
    parse_datetime__572(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__572(rest, acc, stack, context, line, offset) do
    parse_datetime__573(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__573(rest, acc, stack, context, line, offset) do
    parse_datetime__579(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__575(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__576(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__575(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__570(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__576(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__570(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__576(rest, acc, stack, context, line, offset) do
    parse_datetime__577(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__577(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__574(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__578(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__575(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__579(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__580(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__579(rest, acc, stack, context, line, offset) do
    parse_datetime__578(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__580(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__574(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__574(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__581(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__581(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__582(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__582(rest, acc, stack, context, line, offset) do
    parse_datetime__586(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__584(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__583(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__585(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__584(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__586(rest, acc, stack, context, line, offset) do
    parse_datetime__587(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__587(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__588(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__587(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__588(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__587(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__588(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__587(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__588(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__587(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__588(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__587(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__585(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__588(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__589(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__589(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__583(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__583(rest, acc, stack, context, line, offset) do
    parse_datetime__601(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__591(rest, acc, stack, context, line, offset) do
    parse_datetime__592(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__592(rest, acc, stack, context, line, offset) do
    parse_datetime__593(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__593(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__593(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__593(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__593(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__593(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__593(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__593(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__593(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__593(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__593(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__593(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__593(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__594(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__593(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__594(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__593(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__570(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__594(rest, acc, stack, context, line, offset) do
    parse_datetime__595(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__595(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__596(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__595(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__596(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__596(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__597(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__597(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__598(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__598(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__599(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__599(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__590(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__600(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__591(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__601(rest, acc, stack, context, line, offset) do
    parse_datetime__602(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__602(rest, acc, stack, context, line, offset) do
    parse_datetime__603(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__603(rest, acc, stack, context, line, offset) do
    parse_datetime__609(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__605(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__606(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__605(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__600(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__606(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__600(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__606(rest, acc, stack, context, line, offset) do
    parse_datetime__607(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__607(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__604(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__608(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__605(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__609(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__610(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__609(rest, acc, stack, context, line, offset) do
    parse_datetime__608(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__610(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__604(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__604(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__611(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__611(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__612(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__612(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__590(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__590(rest, acc, stack, context, line, offset) do
    parse_datetime__616(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__614(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__613(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__615(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__614(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__616(rest, acc, stack, context, line, offset) do
    parse_datetime__617(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__617(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__618(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__617(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__618(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__617(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__618(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__617(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__618(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__617(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__618(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__617(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__615(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__618(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__619(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__619(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__613(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__613(rest, acc, stack, context, line, offset) do
    parse_datetime__620(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__620(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__621(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__620(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__570(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__621(rest, acc, stack, context, line, offset) do
    parse_datetime__623(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__623(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__624(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__623(rest, acc, stack, context, line, offset) do
    parse_datetime__622(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__622(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__625(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__624(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__625(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__624(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__623(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__625(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__626(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__626(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__627(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__571(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__628(rest, acc, stack, context, line, offset) do
    parse_datetime__629(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__629(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__630(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__629(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__627(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__630(rest, acc, stack, context, line, offset) do
    parse_datetime__632(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__632(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__633(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__632(rest, acc, stack, context, line, offset) do
    parse_datetime__631(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__631(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__634(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__633(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__634(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__633(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__632(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__634(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__635(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__635(rest, acc, stack, context, line, offset) do
    parse_datetime__639(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__637(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__636(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__638(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__637(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__639(rest, acc, stack, context, line, offset) do
    parse_datetime__640(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__640(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__641(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__640(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__641(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__640(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__641(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__640(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__641(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__640(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__641(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__640(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__638(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__641(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__642(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__642(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__636(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__636(rest, acc, stack, context, line, offset) do
    parse_datetime__654(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__644(rest, acc, stack, context, line, offset) do
    parse_datetime__645(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__645(rest, acc, stack, context, line, offset) do
    parse_datetime__646(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__646(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__646(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__646(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__646(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__646(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__646(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__646(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__646(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__646(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__646(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__646(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__646(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__647(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__646(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__647(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__646(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__627(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__647(rest, acc, stack, context, line, offset) do
    parse_datetime__648(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__648(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__649(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__648(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__649(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__649(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__650(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__650(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__651(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__651(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__652(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__652(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__643(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__653(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__644(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__654(rest, acc, stack, context, line, offset) do
    parse_datetime__655(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__655(rest, acc, stack, context, line, offset) do
    parse_datetime__656(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__656(rest, acc, stack, context, line, offset) do
    parse_datetime__662(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__658(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__659(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__658(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__653(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__659(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__653(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__659(rest, acc, stack, context, line, offset) do
    parse_datetime__660(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__660(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__657(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__661(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__658(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__662(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__663(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__662(rest, acc, stack, context, line, offset) do
    parse_datetime__661(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__663(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__657(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__657(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__664(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__664(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__665(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__665(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__643(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__643(rest, acc, stack, context, line, offset) do
    parse_datetime__669(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__667(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__666(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__668(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__667(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__669(rest, acc, stack, context, line, offset) do
    parse_datetime__670(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__670(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__671(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__670(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__671(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__670(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__671(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__670(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__671(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__670(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__671(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__670(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__668(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__671(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__672(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__672(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__666(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__666(rest, acc, stack, context, line, offset) do
    parse_datetime__673(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__673(rest, acc, stack, context, line, offset) do
    parse_datetime__674(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__674(rest, acc, stack, context, line, offset) do
    parse_datetime__680(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__676(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__677(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__676(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__627(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__677(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__627(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__677(rest, acc, stack, context, line, offset) do
    parse_datetime__678(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__678(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__675(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__679(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__676(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__680(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__681(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__680(rest, acc, stack, context, line, offset) do
    parse_datetime__679(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__681(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__675(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__675(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__682(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__682(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__683(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__683(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__684(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__628(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__685(rest, acc, stack, context, line, offset) do
    parse_datetime__686(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__686(rest, acc, stack, context, line, offset) do
    parse_datetime__687(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__687(rest, acc, stack, context, line, offset) do
    parse_datetime__693(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__689(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__690(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__689(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__684(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__690(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__684(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__690(rest, acc, stack, context, line, offset) do
    parse_datetime__691(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__691(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__688(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__692(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__689(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__693(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__694(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__693(rest, acc, stack, context, line, offset) do
    parse_datetime__692(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__694(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__688(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__688(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__695(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__695(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__696(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__696(rest, acc, stack, context, line, offset) do
    parse_datetime__700(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__698(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__697(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__699(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__698(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__700(rest, acc, stack, context, line, offset) do
    parse_datetime__701(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__701(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__702(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__701(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__702(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__701(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__702(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__701(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__702(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__701(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__702(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__701(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__699(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__702(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__703(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__703(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__697(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__697(rest, acc, stack, context, line, offset) do
    parse_datetime__715(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__705(rest, acc, stack, context, line, offset) do
    parse_datetime__706(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__706(rest, acc, stack, context, line, offset) do
    parse_datetime__707(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__707(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__707(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__707(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__707(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__707(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__707(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__707(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__707(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__707(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__707(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__707(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__707(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__708(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__707(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__708(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__707(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__684(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__708(rest, acc, stack, context, line, offset) do
    parse_datetime__709(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__709(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__710(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__709(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__710(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__710(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__711(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__711(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__712(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__712(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__713(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__713(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__704(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__714(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__705(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__715(rest, acc, stack, context, line, offset) do
    parse_datetime__716(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__716(rest, acc, stack, context, line, offset) do
    parse_datetime__717(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__717(rest, acc, stack, context, line, offset) do
    parse_datetime__723(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__719(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__720(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__719(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__714(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__720(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__714(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__720(rest, acc, stack, context, line, offset) do
    parse_datetime__721(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__721(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__718(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__722(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__719(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__723(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__724(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__723(rest, acc, stack, context, line, offset) do
    parse_datetime__722(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__724(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__718(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__718(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__725(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__725(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__726(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__726(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__704(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__704(rest, acc, stack, context, line, offset) do
    parse_datetime__727(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__727(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__728(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__727(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__728(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__727(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__728(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__727(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__728(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__727(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__728(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__727(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__684(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__728(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__729(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__729(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime__730(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime__729(rest, acc, stack, context, line, offset) do
    parse_datetime__684(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__730(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__731(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__685(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__732(rest, acc, stack, context, line, offset) do
    parse_datetime__733(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__733(rest, acc, stack, context, line, offset) do
    parse_datetime__734(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__734(rest, acc, stack, context, line, offset) do
    parse_datetime__740(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__736(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__737(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__736(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__731(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__737(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__731(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__737(rest, acc, stack, context, line, offset) do
    parse_datetime__738(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__738(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__735(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__739(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__736(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__740(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__741(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__740(rest, acc, stack, context, line, offset) do
    parse_datetime__739(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__741(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__735(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__735(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__742(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__742(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__743(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__743(rest, acc, stack, context, line, offset) do
    parse_datetime__747(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__745(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__744(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__746(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__745(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__747(rest, acc, stack, context, line, offset) do
    parse_datetime__748(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__748(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__749(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__748(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__749(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__748(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__749(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__748(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__749(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__748(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__749(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__748(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__746(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__749(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__750(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__750(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__744(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__744(rest, acc, stack, context, line, offset) do
    parse_datetime__751(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__751(rest, acc, stack, context, line, offset) do
    parse_datetime__752(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__752(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__752(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__752(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__752(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__752(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__752(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__752(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__752(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__752(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__752(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__752(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__752(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__753(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__752(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__753(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__752(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__731(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__753(rest, acc, stack, context, line, offset) do
    parse_datetime__754(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__754(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__755(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__754(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__755(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__755(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__756(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__756(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__757(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__757(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__758(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__758(rest, acc, stack, context, line, offset) do
    parse_datetime__762(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__760(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__759(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__761(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__760(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__762(rest, acc, stack, context, line, offset) do
    parse_datetime__763(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__763(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__764(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__763(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__764(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__763(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__764(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__763(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__764(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__763(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__764(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__763(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__761(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__764(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__765(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__765(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__759(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__759(rest, acc, stack, context, line, offset) do
    parse_datetime__766(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__766(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__767(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__766(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__731(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__767(rest, acc, stack, context, line, offset) do
    parse_datetime__769(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_datetime__769(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__770(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__769(rest, acc, stack, context, line, offset) do
    parse_datetime__768(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__768(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__771(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__770(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__771(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__770(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__769(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__771(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__772(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__772(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__394(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__394(rest, acc, stack, context, line, offset) do
    parse_datetime__773(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__773(rest, acc, stack, context, line, offset) do
    parse_datetime__777(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__775(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__774(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__776(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__775(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__777(<<"t", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__778(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__777(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__778(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__777(<<"+", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__778(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__777(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__778(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__777(rest, acc, stack, context, line, offset) do
    parse_datetime__776(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__778(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__774(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__774(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__779(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__779(rest, acc, stack, context, line, offset) do
    parse_datetime__783(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__781(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__780(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__782(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__781(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__783(rest, acc, stack, context, line, offset) do
    parse_datetime__801(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__785(rest, acc, stack, context, line, offset) do
    parse_datetime__786(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__786(rest, acc, stack, context, line, offset) do
    parse_datetime__787(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__787(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__787(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__788(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__787(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__788(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__788(rest, acc, stack, context, line, offset) do
    parse_datetime__789(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__789(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__790(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__790(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__791(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__791(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__792(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__791(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__792(rest, acc, stack, context, line, offset) do
    parse_datetime__793(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__793(rest, acc, stack, context, line, offset) do
    parse_datetime__794(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__794(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__794(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__795(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__794(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__795(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__795(rest, acc, stack, context, line, offset) do
    parse_datetime__796(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__796(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__797(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__797(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__798(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__798(<<":", _::binary>> = rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__782(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__798(rest, acc, stack, context, line, offset) do
    parse_datetime__799(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__799(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__784(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__800(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__785(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__801(rest, acc, stack, context, line, offset) do
    parse_datetime__802(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__802(rest, acc, stack, context, line, offset) do
    parse_datetime__803(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__803(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__803(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__804(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__803(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__804(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__804(rest, acc, stack, context, line, offset) do
    parse_datetime__805(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__805(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__806(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__806(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__807(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__807(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__808(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__807(rest, acc, stack, context, line, offset) do
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__808(rest, acc, stack, context, line, offset) do
    parse_datetime__809(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__809(rest, acc, stack, context, line, offset) do
    parse_datetime__810(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__810(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__810(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__811(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__810(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__811(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__811(rest, acc, stack, context, line, offset) do
    parse_datetime__812(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__812(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__813(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__813(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__814(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__814(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__815(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__814(rest, acc, stack, context, line, offset) do
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__815(rest, acc, stack, context, line, offset) do
    parse_datetime__816(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__816(rest, acc, stack, context, line, offset) do
    parse_datetime__817(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__817(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__817(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__818(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__817(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__818(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__800(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__818(rest, acc, stack, context, line, offset) do
    parse_datetime__819(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__819(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__820(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__820(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__821(
      rest,
      [
        second:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__821(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__822(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__821(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__822(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__822(rest, acc, stack, context, line, offset) do
    parse_datetime__826(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__824(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__823(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__825(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__824(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__826(rest, acc, stack, context, line, offset) do
    parse_datetime__827(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__827(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__828(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__827(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__825(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__828(rest, acc, stack, context, line, offset) do
    parse_datetime__830(rest, acc, [23 | stack], context, line, offset)
  end

  defp parse_datetime__830(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__831(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__830(rest, acc, stack, context, line, offset) do
    parse_datetime__829(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__829(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__832(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__831(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__832(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__831(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__830(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__832(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__833(
      rest,
      [microsecond: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__833(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__823(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__823(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__784(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__784(rest, acc, stack, context, line, offset) do
    parse_datetime__834(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__834(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__835(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__834(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__835(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__835(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__836(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__836(rest, acc, stack, context, line, offset) do
    parse_datetime__840(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__838(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__837(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__839(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__838(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__840(rest, acc, stack, context, line, offset) do
    parse_datetime__841(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__841(<<"am", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["am"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__841(<<"a.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["a.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__841(
         <<"a.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__842(rest, ["a.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__841(<<"a_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["a_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__841(<<"pm", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["pm"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__841(<<"p.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["p.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__841(
         <<"p.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__842(rest, ["p.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__841(<<"p_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["p_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__841(<<"a", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["a"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__841(<<"p", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__842(rest, ["p"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__841(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__839(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__842(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 === 116 or x0 === 109 or x0 === 97 or x0 === 115 or x0 === 100 or x0 === 101 or
              x0 === 111 or
              x0 === 108 or x0 === 107 do
    [acc | stack] = stack
    parse_datetime__839(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__842(rest, acc, stack, context, line, offset) do
    parse_datetime__843(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__843(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__844(
      rest,
      [
        am_pm:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__844(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__837(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__837(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__780(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__780(rest, acc, stack, context, line, offset) do
    parse_datetime__845(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__845(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__846(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__845(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__846(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__846(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__847(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__847(rest, acc, stack, context, line, offset) do
    parse_datetime__851(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__849(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__848(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__850(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__849(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__851(rest, acc, stack, context, line, offset) do
    parse_datetime__879(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__853(rest, acc, stack, context, line, offset) do
    parse_datetime__854(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__854(<<"utc", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["utc"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"gmt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["gmt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"z", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["z"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__854(
         <<"eastern", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["eastern"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__854(<<"est", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["est"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"edt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["edt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"et", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["et"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__854(
         <<"pacific", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["pacific"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__854(<<"pst", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["pst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"pdt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["pdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"pt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["pt"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__854(
         <<"central", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["central"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__854(<<"cst", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["cst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"cdt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["cdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"ct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["ct"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__854(
         <<"mountain", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["mountain"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__854(<<"mst", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["mst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"mdt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["mdt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"mt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["mt"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__854(
         <<"alaska", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["alaska"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__854(
         <<"akst", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["akst"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__854(
         <<"akdt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["akdt"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__854(<<"akt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["akt"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(
         <<"hawaii", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["hawaii"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__854(
         <<"hast", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["hast"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__854(
         <<"hadt", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__855(rest, ["hadt"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__854(<<"hat", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["hat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(<<"hst", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__855(rest, ["hst"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__854(rest, _acc, stack, context, line, offset) do
    [_, _, acc | stack] = stack
    parse_datetime__850(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__855(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__856(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__856(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__857(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__853(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__858(rest, acc, stack, context, line, offset) do
    parse_datetime__859(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__859(<<"+", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__860(rest, ["+"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__859(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__860(rest, ["-"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__859(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__857(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__860(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__861(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__860(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__857(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__861(rest, acc, stack, context, line, offset) do
    parse_datetime__863(rest, acc, [1 | stack], context, line, offset)
  end

  defp parse_datetime__863(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__864(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__863(rest, acc, stack, context, line, offset) do
    parse_datetime__862(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__862(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__865(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__864(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__865(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__864(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__863(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__865(rest, acc, stack, context, line, offset) do
    parse_datetime__866(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__866(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__867(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__866(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__867(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__867(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__868(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__868(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__869(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__868(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__869(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__869(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__870(
      rest,
      [utc_offset: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__870(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__871(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__858(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__872(rest, acc, stack, context, line, offset) do
    parse_datetime__873(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__873(rest, acc, stack, context, line, offset) do
    parse_datetime__874(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__874(<<"utc", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__875(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__874(<<"gmt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__875(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__874(<<"z", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__875(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__874(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__871(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__875(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__876(rest, ["UTC"] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__876(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__877(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__877(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__878(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__872(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__879(rest, acc, stack, context, line, offset) do
    parse_datetime__880(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__880(rest, acc, stack, context, line, offset) do
    parse_datetime__881(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__881(<<"utc", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__882(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__881(<<"gmt", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__882(rest, acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__881(<<"z", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__882(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__881(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__878(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__882(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__883(rest, ["UTC"] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__883(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__884(
      rest,
      [
        zone_abbr:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__884(rest, acc, stack, context, line, offset) do
    parse_datetime__885(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__885(<<"+", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__886(rest, ["+"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__885(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__886(rest, ["-"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__885(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__878(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__886(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__887(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__886(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__878(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__887(rest, acc, stack, context, line, offset) do
    parse_datetime__889(rest, acc, [1 | stack], context, line, offset)
  end

  defp parse_datetime__889(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__890(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__889(rest, acc, stack, context, line, offset) do
    parse_datetime__888(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__888(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__891(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__890(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__891(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__890(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__889(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__891(rest, acc, stack, context, line, offset) do
    parse_datetime__892(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__892(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__893(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__892(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__893(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__893(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__894(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__894(
         <<x0, x1, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_datetime__895(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__894(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__895(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__895(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__896(
      rest,
      [utc_offset: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__896(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__852(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__852(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__848(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__848(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__897(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__393(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__898(rest, acc, stack, context, line, offset) do
    parse_datetime__899(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__899(rest, acc, stack, context, line, offset) do
    parse_datetime__900(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__900(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_datetime__900(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__900(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__900(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_datetime__900(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__900(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_datetime__900(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_datetime__900(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__900(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_datetime__900(
         <<"sept", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__900(
         <<"june", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__900(
         <<"july", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__901(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__900(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__901(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__900(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__901(rest, acc, stack, context, line, offset) do
    parse_datetime__902(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__902(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__903(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__902(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__903(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__903(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__904(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__904(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__905(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__905(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__906(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__906(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__907(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__906(rest, acc, stack, context, line, offset) do
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__907(rest, acc, stack, context, line, offset) do
    parse_datetime__908(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__908(rest, acc, stack, context, line, offset) do
    parse_datetime__909(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__909(rest, acc, stack, context, line, offset) do
    parse_datetime__915(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__911(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__912(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__911(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__912(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__912(rest, acc, stack, context, line, offset) do
    parse_datetime__913(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__913(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__910(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__914(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__911(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__915(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__916(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__915(rest, acc, stack, context, line, offset) do
    parse_datetime__914(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__916(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__910(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__910(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__917(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__917(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__918(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__918(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__919(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__918(rest, acc, stack, context, line, offset) do
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__919(rest, acc, stack, context, line, offset) do
    parse_datetime__937(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__921(rest, acc, stack, context, line, offset) do
    parse_datetime__922(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__922(rest, acc, stack, context, line, offset) do
    parse_datetime__923(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__923(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__923(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__924(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__923(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__924(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__924(rest, acc, stack, context, line, offset) do
    parse_datetime__925(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__925(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__926(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__926(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__927(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__927(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__928(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__927(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__928(rest, acc, stack, context, line, offset) do
    parse_datetime__929(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__929(rest, acc, stack, context, line, offset) do
    parse_datetime__930(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__930(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__930(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__931(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__930(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__931(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__931(rest, acc, stack, context, line, offset) do
    parse_datetime__932(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__932(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__933(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__933(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__934(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__934(<<":", _::binary>> = rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__934(rest, acc, stack, context, line, offset) do
    parse_datetime__935(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__935(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__920(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__936(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__921(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__937(rest, acc, stack, context, line, offset) do
    parse_datetime__938(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__938(rest, acc, stack, context, line, offset) do
    parse_datetime__939(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__939(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__939(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__940(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__939(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__940(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__940(rest, acc, stack, context, line, offset) do
    parse_datetime__941(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__941(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__942(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__942(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__943(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__943(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__944(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__943(rest, acc, stack, context, line, offset) do
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__944(rest, acc, stack, context, line, offset) do
    parse_datetime__945(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__945(rest, acc, stack, context, line, offset) do
    parse_datetime__946(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__946(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__946(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__947(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__946(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__947(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__947(rest, acc, stack, context, line, offset) do
    parse_datetime__948(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__948(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__949(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__949(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__950(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__950(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__951(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__950(rest, acc, stack, context, line, offset) do
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__951(rest, acc, stack, context, line, offset) do
    parse_datetime__952(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__952(rest, acc, stack, context, line, offset) do
    parse_datetime__953(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__953(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__953(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__954(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__953(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__954(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_datetime__936(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__954(rest, acc, stack, context, line, offset) do
    parse_datetime__955(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__955(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__956(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__956(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__957(
      rest,
      [
        second:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__957(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__958(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__957(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__958(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__958(rest, acc, stack, context, line, offset) do
    parse_datetime__962(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__960(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__959(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__961(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__960(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__962(rest, acc, stack, context, line, offset) do
    parse_datetime__963(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__963(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__964(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__963(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__961(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__964(rest, acc, stack, context, line, offset) do
    parse_datetime__966(rest, acc, [23 | stack], context, line, offset)
  end

  defp parse_datetime__966(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_datetime__967(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__966(rest, acc, stack, context, line, offset) do
    parse_datetime__965(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__965(rest, acc, [_ | stack], context, line, offset) do
    parse_datetime__968(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__967(rest, acc, [1 | stack], context, line, offset) do
    parse_datetime__968(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__967(rest, acc, [count | stack], context, line, offset) do
    parse_datetime__966(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_datetime__968(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__969(
      rest,
      [microsecond: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__969(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__959(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__959(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__920(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__920(rest, acc, stack, context, line, offset) do
    parse_datetime__970(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__970(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__971(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__970(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__971(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__971(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__972(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__972(rest, acc, stack, context, line, offset) do
    parse_datetime__976(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_datetime__974(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__973(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__975(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_datetime__974(rest, [], stack, context, line, offset)
  end

  defp parse_datetime__976(rest, acc, stack, context, line, offset) do
    parse_datetime__977(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__977(<<"am", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["am"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__977(<<"a.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["a.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__977(
         <<"a.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__978(rest, ["a.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__977(<<"a_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["a_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__977(<<"pm", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["pm"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_datetime__977(<<"p.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["p.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__977(
         <<"p.m.", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_datetime__978(rest, ["p.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_datetime__977(<<"p_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["p_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_datetime__977(<<"a", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["a"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__977(<<"p", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__978(rest, ["p"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__977(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_datetime__975(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__978(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 === 116 or x0 === 109 or x0 === 97 or x0 === 115 or x0 === 100 or x0 === 101 or
              x0 === 111 or
              x0 === 108 or x0 === 107 do
    [acc | stack] = stack
    parse_datetime__975(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__978(rest, acc, stack, context, line, offset) do
    parse_datetime__979(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__979(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_datetime__980(
      rest,
      [
        am_pm:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_datetime__980(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__973(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__973(rest, acc, stack, context, line, offset) do
    parse_datetime__981(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_datetime__981(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__982(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_datetime__981(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_datetime__982(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_datetime__982(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_datetime__983(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_datetime__983(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_datetime__984(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_datetime__983(rest, acc, stack, context, line, offset) do
    parse_datetime__897(rest, acc, stack, context, line, offset)
  end

  defp parse_datetime__984(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_datetime__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_datetime__11(rest, acc, _stack, context, line, offset) do
    {:ok, acc, rest, context, line, offset}
  end

  @doc """
  Parses the given `binary` as parse_date_us.

  Returns `{:ok, [token], rest, context, position, byte_offset}` or
  `{:error, reason, rest, context, line, byte_offset}` where `position`
  describes the location of the parse_date_us (start position) as `{line, offset_to_start_of_line}`.

  To column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.

  ## Options

    * `:byte_offset` - the byte offset for the whole binary, defaults to 0
    * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`
    * `:context` - the initial context value. It will be converted to a map

  """
  @spec parse_date_us(binary, keyword) ::
          {:ok, [term], rest, context, line, byte_offset}
          | {:error, reason, rest, context, line, byte_offset}
        when line: {pos_integer, byte_offset},
             byte_offset: pos_integer,
             rest: binary,
             reason: String.t(),
             context: map
  def parse_date_us(binary, opts \\ []) when is_binary(binary) do
    context = Map.new(Keyword.get(opts, :context, []))
    byte_offset = Keyword.get(opts, :byte_offset, 0)

    line =
      case Keyword.get(opts, :line, 1) do
        {_, _} = line -> line
        line -> {line, byte_offset}
      end

    case parse_date_us__0(binary, [], [], context, line, byte_offset) do
      {:ok, acc, rest, context, line, offset} ->
        {:ok, :lists.reverse(acc), rest, context, line, offset}

      {:error, _, _, _, _, _} = error ->
        error
    end
  end

  defp parse_date_us__0(rest, acc, stack, context, line, offset) do
    parse_date_us__4(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__2(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__3(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__2(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__4(rest, acc, stack, context, line, offset) do
    parse_date_us__5(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__5(
         <<"wednesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__6(rest, ["wednesday"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__5(
         <<"thursday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__6(rest, ["thursday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__5(
         <<"saturday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__6(rest, ["saturday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__5(
         <<"tuesday", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__6(rest, ["tuesday"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__5(<<"sunday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["sunday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__5(<<"monday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["monday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__5(<<"friday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["friday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__5(<<"thurs", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["thurs"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__5(<<"tues", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["tues"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__5(<<"thur", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["thur"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__5(<<"wed", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["wed"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"tue", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["tue"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"thu", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["thu"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"sun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["sun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"sat", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["sat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"mon", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["mon"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(<<"fri", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__6(rest, ["fri"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__5(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__3(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__6(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__7(
      rest,
      [
        vocal_day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__7(rest, acc, stack, context, line, offset) do
    parse_date_us__8(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__8(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__9(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__8(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__9(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__9(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__10(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__10(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__1(rest, acc, stack, context, line, offset) do
    parse_date_us__353(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__12(rest, acc, stack, context, line, offset) do
    parse_date_us__13(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__13(rest, acc, stack, context, line, offset) do
    parse_date_us__14(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__14(rest, acc, stack, context, line, offset) do
    parse_date_us__20(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__16(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__17(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__16(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric day from 01-31 while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date_us__17(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    {:error,
     "did not expect numeric day from 01-31 while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date_us__17(rest, acc, stack, context, line, offset) do
    parse_date_us__18(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__18(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__15(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__19(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__16(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__20(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__21(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__20(rest, acc, stack, context, line, offset) do
    parse_date_us__19(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__21(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__15(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__15(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__22(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__22(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__23(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__23(rest, acc, stack, context, line, offset) do
    parse_date_us__27(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__25(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__24(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__26(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__25(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__27(rest, acc, stack, context, line, offset) do
    parse_date_us__28(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__28(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__28(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__28(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__28(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__28(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__28(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__26(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__29(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__30(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__30(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__24(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__24(rest, acc, stack, context, line, offset) do
    parse_date_us__42(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__32(rest, acc, stack, context, line, offset) do
    parse_date_us__33(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__33(rest, acc, stack, context, line, offset) do
    parse_date_us__34(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__34(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__34(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__34(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__34(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__34(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__34(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__34(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__35(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__34(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__34(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__34(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__34(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__34(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__34(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__35(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__34(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected word month either fully spelled or 3-letter abbreviation while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date_us__35(rest, acc, stack, context, line, offset) do
    parse_date_us__36(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__36(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__37(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__36(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__37(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__37(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__38(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__38(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__39(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__39(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__40(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__40(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__31(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__41(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__32(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__42(rest, acc, stack, context, line, offset) do
    parse_date_us__43(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__43(rest, acc, stack, context, line, offset) do
    parse_date_us__44(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__44(rest, acc, stack, context, line, offset) do
    parse_date_us__50(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__46(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__47(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__46(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__41(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__47(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__41(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__47(rest, acc, stack, context, line, offset) do
    parse_date_us__48(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__48(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__45(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__49(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__46(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__50(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__51(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__50(rest, acc, stack, context, line, offset) do
    parse_date_us__49(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__51(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__45(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__45(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__52(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__52(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__53(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__53(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__31(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__31(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__54(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__12(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__55(rest, acc, stack, context, line, offset) do
    parse_date_us__67(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__57(rest, acc, stack, context, line, offset) do
    parse_date_us__58(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__58(rest, acc, stack, context, line, offset) do
    parse_date_us__59(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__59(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__59(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__59(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__59(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__59(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__59(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__59(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__60(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__59(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__59(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__59(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__59(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__59(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__59(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__60(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__59(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__60(rest, acc, stack, context, line, offset) do
    parse_date_us__61(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__61(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__62(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__61(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__62(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__62(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__63(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__63(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__64(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__64(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__65(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__65(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__56(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__66(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__57(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__67(rest, acc, stack, context, line, offset) do
    parse_date_us__68(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__68(rest, acc, stack, context, line, offset) do
    parse_date_us__69(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__69(rest, acc, stack, context, line, offset) do
    parse_date_us__75(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__71(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__72(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__71(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__66(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__72(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__66(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__72(rest, acc, stack, context, line, offset) do
    parse_date_us__73(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__73(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__70(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__74(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__71(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__75(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__76(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__75(rest, acc, stack, context, line, offset) do
    parse_date_us__74(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__76(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__70(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__70(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__77(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__77(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__78(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__78(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__56(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__56(rest, acc, stack, context, line, offset) do
    parse_date_us__82(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__80(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__79(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__81(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__80(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__82(rest, acc, stack, context, line, offset) do
    parse_date_us__83(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__83(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__83(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__83(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__83(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__83(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__83(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__81(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__84(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__85(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__85(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__79(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__79(rest, acc, stack, context, line, offset) do
    parse_date_us__86(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__86(rest, acc, stack, context, line, offset) do
    parse_date_us__87(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__87(rest, acc, stack, context, line, offset) do
    parse_date_us__93(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__89(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__90(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__89(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__90(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__90(rest, acc, stack, context, line, offset) do
    parse_date_us__91(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__91(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__88(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__92(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__89(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__93(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__94(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__93(rest, acc, stack, context, line, offset) do
    parse_date_us__92(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__94(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__88(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__88(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__95(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__95(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__96(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__96(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__97(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__55(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__98(rest, acc, stack, context, line, offset) do
    parse_date_us__99(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__99(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date_us__100(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__99(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__100(rest, acc, stack, context, line, offset) do
    parse_date_us__102(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date_us__102(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date_us__103(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__102(rest, acc, stack, context, line, offset) do
    parse_date_us__101(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__101(rest, acc, [_ | stack], context, line, offset) do
    parse_date_us__104(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__103(rest, acc, [1 | stack], context, line, offset) do
    parse_date_us__104(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__103(rest, acc, [count | stack], context, line, offset) do
    parse_date_us__102(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date_us__104(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__105(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__105(rest, acc, stack, context, line, offset) do
    parse_date_us__109(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__107(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__106(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__108(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__107(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__109(rest, acc, stack, context, line, offset) do
    parse_date_us__110(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__110(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__111(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__110(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__111(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__110(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__111(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__110(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__111(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__110(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__111(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__110(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__108(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__111(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__112(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__112(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__106(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__106(rest, acc, stack, context, line, offset) do
    parse_date_us__124(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__114(rest, acc, stack, context, line, offset) do
    parse_date_us__115(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__115(rest, acc, stack, context, line, offset) do
    parse_date_us__116(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__116(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__116(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__116(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__116(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__116(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__116(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__116(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__116(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__116(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__117(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__116(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__116(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__116(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__116(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__117(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__116(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__117(rest, acc, stack, context, line, offset) do
    parse_date_us__118(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__118(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__119(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__118(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__119(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__119(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__120(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__120(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__121(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__121(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__122(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__122(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__113(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__123(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__114(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__124(rest, acc, stack, context, line, offset) do
    parse_date_us__125(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__125(rest, acc, stack, context, line, offset) do
    parse_date_us__126(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__126(rest, acc, stack, context, line, offset) do
    parse_date_us__132(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__128(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__129(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__128(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__123(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__129(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__123(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__129(rest, acc, stack, context, line, offset) do
    parse_date_us__130(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__130(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__127(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__131(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__128(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__132(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__133(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__132(rest, acc, stack, context, line, offset) do
    parse_date_us__131(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__133(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__127(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__127(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__134(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__134(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__135(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__135(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__113(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__113(rest, acc, stack, context, line, offset) do
    parse_date_us__139(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__137(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__136(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__138(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__137(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__139(rest, acc, stack, context, line, offset) do
    parse_date_us__140(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__140(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__141(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__140(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__141(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__140(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__141(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__140(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__141(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__140(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__141(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__140(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__138(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__141(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__142(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__142(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__136(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__136(rest, acc, stack, context, line, offset) do
    parse_date_us__143(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__143(rest, acc, stack, context, line, offset) do
    parse_date_us__144(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__144(rest, acc, stack, context, line, offset) do
    parse_date_us__150(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__146(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__147(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__146(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__147(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__147(rest, acc, stack, context, line, offset) do
    parse_date_us__148(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__148(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__145(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__149(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__146(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__150(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__151(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__150(rest, acc, stack, context, line, offset) do
    parse_date_us__149(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__151(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__145(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__145(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__152(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__152(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__153(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__153(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__154(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__98(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__155(rest, acc, stack, context, line, offset) do
    parse_date_us__167(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__157(rest, acc, stack, context, line, offset) do
    parse_date_us__158(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__158(rest, acc, stack, context, line, offset) do
    parse_date_us__159(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__159(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__159(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__159(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__159(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__159(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__159(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__159(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__159(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__159(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__160(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__159(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__159(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__159(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__159(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__160(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__159(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__154(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__160(rest, acc, stack, context, line, offset) do
    parse_date_us__161(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__161(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__162(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__161(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__162(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__162(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__163(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__163(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__164(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__164(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__165(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__165(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__156(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__166(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__157(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__167(rest, acc, stack, context, line, offset) do
    parse_date_us__168(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__168(rest, acc, stack, context, line, offset) do
    parse_date_us__169(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__169(rest, acc, stack, context, line, offset) do
    parse_date_us__175(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__171(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__172(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__171(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__166(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__172(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__166(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__172(rest, acc, stack, context, line, offset) do
    parse_date_us__173(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__173(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__170(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__174(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__171(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__175(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__176(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__175(rest, acc, stack, context, line, offset) do
    parse_date_us__174(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__176(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__170(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__170(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__177(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__177(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__178(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__178(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__156(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__156(rest, acc, stack, context, line, offset) do
    parse_date_us__182(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__180(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__179(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__181(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__180(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__182(rest, acc, stack, context, line, offset) do
    parse_date_us__183(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__183(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__184(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__183(<<", ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__184(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__183(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__181(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__184(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__185(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__185(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__179(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__179(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_date_us__186(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_date_us__179(rest, acc, stack, context, line, offset) do
    parse_date_us__154(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__186(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__187(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__155(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__188(rest, acc, stack, context, line, offset) do
    parse_date_us__189(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__189(rest, acc, stack, context, line, offset) do
    parse_date_us__190(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__190(rest, acc, stack, context, line, offset) do
    parse_date_us__196(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__192(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__193(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__192(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__193(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__193(rest, acc, stack, context, line, offset) do
    parse_date_us__194(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__194(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__191(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__195(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__192(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__196(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__197(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__196(rest, acc, stack, context, line, offset) do
    parse_date_us__195(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__197(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__191(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__191(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__198(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__198(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__199(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__199(rest, acc, stack, context, line, offset) do
    parse_date_us__203(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__201(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__200(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__202(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__201(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__203(rest, acc, stack, context, line, offset) do
    parse_date_us__204(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__204(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__204(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__204(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__204(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__204(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__204(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__202(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__205(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__206(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__206(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__200(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__200(rest, acc, stack, context, line, offset) do
    parse_date_us__218(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__208(rest, acc, stack, context, line, offset) do
    parse_date_us__209(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__209(rest, acc, stack, context, line, offset) do
    parse_date_us__210(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__210(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__210(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__210(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__210(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__210(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__210(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__210(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__210(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__210(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__211(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__210(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__210(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__210(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__210(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__211(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__210(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__211(rest, acc, stack, context, line, offset) do
    parse_date_us__212(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__212(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__213(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__212(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__213(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__213(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__214(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__214(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__215(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__215(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__216(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__216(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__207(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__217(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__208(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__218(rest, acc, stack, context, line, offset) do
    parse_date_us__219(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__219(rest, acc, stack, context, line, offset) do
    parse_date_us__220(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__220(rest, acc, stack, context, line, offset) do
    parse_date_us__226(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__222(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__223(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__222(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__217(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__223(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__217(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__223(rest, acc, stack, context, line, offset) do
    parse_date_us__224(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__224(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__221(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__225(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__222(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__226(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__227(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__226(rest, acc, stack, context, line, offset) do
    parse_date_us__225(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__227(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__221(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__221(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__228(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__228(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__229(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__229(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__207(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__207(rest, acc, stack, context, line, offset) do
    parse_date_us__233(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__231(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__230(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__232(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__231(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__233(rest, acc, stack, context, line, offset) do
    parse_date_us__234(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__234(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__234(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__234(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__234(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__234(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__234(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__232(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__235(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__236(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__236(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__230(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__230(rest, acc, stack, context, line, offset) do
    parse_date_us__237(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__237(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date_us__238(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__237(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__238(rest, acc, stack, context, line, offset) do
    parse_date_us__240(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date_us__240(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date_us__241(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__240(rest, acc, stack, context, line, offset) do
    parse_date_us__239(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__239(rest, acc, [_ | stack], context, line, offset) do
    parse_date_us__242(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__241(rest, acc, [1 | stack], context, line, offset) do
    parse_date_us__242(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__241(rest, acc, [count | stack], context, line, offset) do
    parse_date_us__240(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date_us__242(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__243(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__243(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__244(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__188(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__245(rest, acc, stack, context, line, offset) do
    parse_date_us__257(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__247(rest, acc, stack, context, line, offset) do
    parse_date_us__248(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__248(rest, acc, stack, context, line, offset) do
    parse_date_us__249(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__249(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__249(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__249(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__249(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__249(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__249(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__249(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__249(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__249(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__250(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__249(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__249(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__249(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__249(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__250(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__249(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__250(rest, acc, stack, context, line, offset) do
    parse_date_us__251(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__251(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__252(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__251(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__252(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__252(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__253(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__253(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__254(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__254(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__255(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__255(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__246(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__256(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__247(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__257(rest, acc, stack, context, line, offset) do
    parse_date_us__258(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__258(rest, acc, stack, context, line, offset) do
    parse_date_us__259(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__259(rest, acc, stack, context, line, offset) do
    parse_date_us__265(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__261(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__262(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__261(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__256(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__262(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__256(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__262(rest, acc, stack, context, line, offset) do
    parse_date_us__263(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__263(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__260(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__264(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__261(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__265(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__266(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__265(rest, acc, stack, context, line, offset) do
    parse_date_us__264(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__266(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__260(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__260(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__267(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__267(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__268(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__268(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__246(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__246(rest, acc, stack, context, line, offset) do
    parse_date_us__272(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__270(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__269(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__271(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__270(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__272(rest, acc, stack, context, line, offset) do
    parse_date_us__273(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__273(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__274(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__273(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__274(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__273(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__274(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__273(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__274(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__273(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__274(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__273(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__271(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__274(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__275(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__275(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__269(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__269(rest, acc, stack, context, line, offset) do
    parse_date_us__276(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__276(rest, acc, stack, context, line, offset) do
    parse_date_us__277(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__277(rest, acc, stack, context, line, offset) do
    parse_date_us__283(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__279(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__280(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__279(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__280(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__280(rest, acc, stack, context, line, offset) do
    parse_date_us__281(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__281(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__278(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__282(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__279(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__283(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__284(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__283(rest, acc, stack, context, line, offset) do
    parse_date_us__282(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__284(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__278(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__278(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__285(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__285(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__286(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__286(rest, acc, stack, context, line, offset) do
    parse_date_us__290(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__288(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__287(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__289(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__288(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__290(rest, acc, stack, context, line, offset) do
    parse_date_us__291(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__291(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__292(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__291(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__292(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__291(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__292(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__291(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__292(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__291(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__292(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__291(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__289(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__292(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__293(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__293(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__287(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__287(rest, acc, stack, context, line, offset) do
    parse_date_us__294(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__294(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date_us__295(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__294(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__295(rest, acc, stack, context, line, offset) do
    parse_date_us__297(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date_us__297(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date_us__298(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__297(rest, acc, stack, context, line, offset) do
    parse_date_us__296(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__296(rest, acc, [_ | stack], context, line, offset) do
    parse_date_us__299(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__298(rest, acc, [1 | stack], context, line, offset) do
    parse_date_us__299(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__298(rest, acc, [count | stack], context, line, offset) do
    parse_date_us__297(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date_us__299(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__300(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__300(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__301(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__245(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__302(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_date_us__303(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_date_us__302(rest, acc, stack, context, line, offset) do
    parse_date_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__303(rest, acc, stack, context, line, offset) do
    parse_date_us__307(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__305(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__304(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__306(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__305(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__307(rest, acc, stack, context, line, offset) do
    parse_date_us__308(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__308(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__309(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__308(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__309(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__308(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__309(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__308(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__309(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__308(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__309(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__308(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__306(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__309(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__310(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__310(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__304(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__304(rest, acc, stack, context, line, offset) do
    parse_date_us__322(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__312(rest, acc, stack, context, line, offset) do
    parse_date_us__313(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__313(rest, acc, stack, context, line, offset) do
    parse_date_us__314(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__314(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__314(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__314(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__314(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__314(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__314(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__314(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__314(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__314(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__315(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__314(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__314(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__314(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__314(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__315(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__314(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__315(rest, acc, stack, context, line, offset) do
    parse_date_us__316(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__316(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__317(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__316(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__317(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__317(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__318(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__318(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__319(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__319(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__320(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__320(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__311(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__321(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__312(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__322(rest, acc, stack, context, line, offset) do
    parse_date_us__323(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__323(rest, acc, stack, context, line, offset) do
    parse_date_us__324(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__324(rest, acc, stack, context, line, offset) do
    parse_date_us__330(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__326(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__327(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__326(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__321(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__327(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__321(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__327(rest, acc, stack, context, line, offset) do
    parse_date_us__328(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__328(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__325(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__329(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__326(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__330(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__331(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__330(rest, acc, stack, context, line, offset) do
    parse_date_us__329(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__331(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__325(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__325(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__332(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__332(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__333(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__333(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__311(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__311(rest, acc, stack, context, line, offset) do
    parse_date_us__337(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__335(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__334(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__336(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__335(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__337(rest, acc, stack, context, line, offset) do
    parse_date_us__338(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__338(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__339(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__338(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__339(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__338(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__339(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__338(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__339(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__338(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__339(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__338(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__336(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__339(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__340(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__340(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__334(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__334(rest, acc, stack, context, line, offset) do
    parse_date_us__341(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__341(rest, acc, stack, context, line, offset) do
    parse_date_us__342(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__342(rest, acc, stack, context, line, offset) do
    parse_date_us__348(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__344(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__345(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__344(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__345(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__345(rest, acc, stack, context, line, offset) do
    parse_date_us__346(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__346(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__343(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__347(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__344(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__348(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__349(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__348(rest, acc, stack, context, line, offset) do
    parse_date_us__347(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__349(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__343(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__343(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__350(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__350(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__351(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__351(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__352(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__302(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__353(rest, acc, stack, context, line, offset) do
    parse_date_us__354(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__354(rest, acc, stack, context, line, offset) do
    parse_date_us__355(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__355(rest, acc, stack, context, line, offset) do
    parse_date_us__361(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__357(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__358(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__357(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date_us__352(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__358(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date_us__352(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__358(rest, acc, stack, context, line, offset) do
    parse_date_us__359(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__359(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__356(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__360(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__357(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__361(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__362(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__361(rest, acc, stack, context, line, offset) do
    parse_date_us__360(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__362(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__356(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__356(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__363(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__363(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__364(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__364(rest, acc, stack, context, line, offset) do
    parse_date_us__368(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__366(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__365(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__367(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__366(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__368(rest, acc, stack, context, line, offset) do
    parse_date_us__369(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__369(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__370(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__369(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__370(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__369(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__370(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__369(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__370(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__369(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__370(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__369(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__367(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__370(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__371(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__371(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__365(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__365(rest, acc, stack, context, line, offset) do
    parse_date_us__372(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__372(rest, acc, stack, context, line, offset) do
    parse_date_us__373(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__373(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date_us__373(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__373(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__373(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date_us__373(
         <<"october", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__373(
         <<"january", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date_us__373(
         <<"august", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date_us__373(
         <<"march", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__373(
         <<"april", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date_us__374(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date_us__373(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__373(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__373(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date_us__373(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__374(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date_us__373(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_date_us__352(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__374(rest, acc, stack, context, line, offset) do
    parse_date_us__375(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__375(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__376(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__375(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__376(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date_us__376(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__377(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__377(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__378(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__378(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__379(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__379(rest, acc, stack, context, line, offset) do
    parse_date_us__383(
      rest,
      [],
      [{rest, context, line, offset}, acc | stack],
      context,
      line,
      offset
    )
  end

  defp parse_date_us__381(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__380(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__382(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date_us__381(rest, [], stack, context, line, offset)
  end

  defp parse_date_us__383(rest, acc, stack, context, line, offset) do
    parse_date_us__384(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__384(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__385(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__384(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__385(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__384(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__385(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__384(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__385(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__384(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date_us__385(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__384(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__382(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__385(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date_us__386(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date_us__386(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__380(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__380(rest, acc, stack, context, line, offset) do
    parse_date_us__387(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date_us__387(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date_us__388(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date_us__387(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date_us__352(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__388(rest, acc, stack, context, line, offset) do
    parse_date_us__390(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date_us__390(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date_us__391(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date_us__390(rest, acc, stack, context, line, offset) do
    parse_date_us__389(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__389(rest, acc, [_ | stack], context, line, offset) do
    parse_date_us__392(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__391(rest, acc, [1 | stack], context, line, offset) do
    parse_date_us__392(rest, acc, stack, context, line, offset)
  end

  defp parse_date_us__391(rest, acc, [count | stack], context, line, offset) do
    parse_date_us__390(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date_us__392(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date_us__393(
      rest,
      [year: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date_us__393(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date_us__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date_us__11(rest, acc, _stack, context, line, offset) do
    {:ok, acc, rest, context, line, offset}
  end

  @doc """
  Parses the given `binary` as parse_date.

  Returns `{:ok, [token], rest, context, position, byte_offset}` or
  `{:error, reason, rest, context, line, byte_offset}` where `position`
  describes the location of the parse_date (start position) as `{line, offset_to_start_of_line}`.

  To column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.

  ## Options

    * `:byte_offset` - the byte offset for the whole binary, defaults to 0
    * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`
    * `:context` - the initial context value. It will be converted to a map

  """
  @spec parse_date(binary, keyword) ::
          {:ok, [term], rest, context, line, byte_offset}
          | {:error, reason, rest, context, line, byte_offset}
        when line: {pos_integer, byte_offset},
             byte_offset: pos_integer,
             rest: binary,
             reason: String.t(),
             context: map
  def parse_date(binary, opts \\ []) when is_binary(binary) do
    context = Map.new(Keyword.get(opts, :context, []))
    byte_offset = Keyword.get(opts, :byte_offset, 0)

    line =
      case Keyword.get(opts, :line, 1) do
        {_, _} = line -> line
        line -> {line, byte_offset}
      end

    case parse_date__0(binary, [], [], context, line, byte_offset) do
      {:ok, acc, rest, context, line, offset} ->
        {:ok, :lists.reverse(acc), rest, context, line, offset}

      {:error, _, _, _, _, _} = error ->
        error
    end
  end

  defp parse_date__0(rest, acc, stack, context, line, offset) do
    parse_date__4(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__2(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__3(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__2(rest, [], stack, context, line, offset)
  end

  defp parse_date__4(rest, acc, stack, context, line, offset) do
    parse_date__5(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__5(<<"wednesday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["wednesday"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__5(<<"thursday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["thursday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__5(<<"saturday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["saturday"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__5(<<"tuesday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["tuesday"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__5(<<"sunday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["sunday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__5(<<"monday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["monday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__5(<<"friday", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["friday"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__5(<<"thurs", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["thurs"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__5(<<"tues", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["tues"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__5(<<"thur", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["thur"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__5(<<"wed", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["wed"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"tue", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["tue"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"thu", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["thu"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"sun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["sun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"sat", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["sat"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"mon", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["mon"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(<<"fri", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__6(rest, ["fri"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__5(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__3(rest, acc, stack, context, line, offset)
  end

  defp parse_date__6(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__7(
      rest,
      [
        vocal_day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__7(rest, acc, stack, context, line, offset) do
    parse_date__8(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__8(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__9(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__8(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__9(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__9(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__10(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__10(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__1(rest, acc, stack, context, line, offset) do
    parse_date__349(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__12(rest, acc, stack, context, line, offset) do
    parse_date__13(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__13(rest, acc, stack, context, line, offset) do
    parse_date__14(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__14(rest, acc, stack, context, line, offset) do
    parse_date__20(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__16(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__17(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__16(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric day from 01-31 while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date__17(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    {:error,
     "did not expect numeric day from 01-31 while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date__17(rest, acc, stack, context, line, offset) do
    parse_date__18(rest, acc, stack, context, line, offset)
  end

  defp parse_date__18(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__15(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__19(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__16(rest, [], stack, context, line, offset)
  end

  defp parse_date__20(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__21(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__20(rest, acc, stack, context, line, offset) do
    parse_date__19(rest, acc, stack, context, line, offset)
  end

  defp parse_date__21(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__15(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__15(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__22(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__22(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__23(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__23(rest, acc, stack, context, line, offset) do
    parse_date__27(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__25(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__24(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__26(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__25(rest, [], stack, context, line, offset)
  end

  defp parse_date__27(rest, acc, stack, context, line, offset) do
    parse_date__28(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__28(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__28(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__28(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__28(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__28(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__29(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__28(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__26(rest, acc, stack, context, line, offset)
  end

  defp parse_date__29(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__30(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__30(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__24(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__24(rest, acc, stack, context, line, offset) do
    parse_date__42(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__32(rest, acc, stack, context, line, offset) do
    parse_date__33(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__33(rest, acc, stack, context, line, offset) do
    parse_date__34(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__34(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__35(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__34(<<"november", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__34(<<"february", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__34(<<"december", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__34(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__34(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__34(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__34(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__34(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__34(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__34(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__34(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__34(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__35(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__34(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected word month either fully spelled or 3-letter abbreviation while processing numeric day from 01-31, followed by date separator or nothing, followed by word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator, followed by 4 digit year or 2 or 4 digit year, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by string \" \" or string \", \" or nothing, followed by 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31, followed by date separator or nothing, followed by 2 or 4 digit year or numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation, followed by date separator or nothing, followed by numeric day from 01-31 or numeric day from 01-31, followed by date separator or nothing, followed by numeric month from 01-12 or word month either fully spelled or 3-letter abbreviation",
     rest, context, line, offset}
  end

  defp parse_date__35(rest, acc, stack, context, line, offset) do
    parse_date__36(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__36(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__37(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__36(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__37(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__37(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__38(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__38(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__39(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__39(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__40(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__40(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__31(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__41(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__32(rest, [], stack, context, line, offset)
  end

  defp parse_date__42(rest, acc, stack, context, line, offset) do
    parse_date__43(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__43(rest, acc, stack, context, line, offset) do
    parse_date__44(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__44(rest, acc, stack, context, line, offset) do
    parse_date__50(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__46(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__47(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__46(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__41(rest, acc, stack, context, line, offset)
  end

  defp parse_date__47(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__41(rest, acc, stack, context, line, offset)
  end

  defp parse_date__47(rest, acc, stack, context, line, offset) do
    parse_date__48(rest, acc, stack, context, line, offset)
  end

  defp parse_date__48(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__45(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__49(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__46(rest, [], stack, context, line, offset)
  end

  defp parse_date__50(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__51(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__50(rest, acc, stack, context, line, offset) do
    parse_date__49(rest, acc, stack, context, line, offset)
  end

  defp parse_date__51(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__45(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__45(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__52(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__52(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__53(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__53(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__31(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__31(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__54(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__12(rest, [], stack, context, line, offset)
  end

  defp parse_date__55(rest, acc, stack, context, line, offset) do
    parse_date__67(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__57(rest, acc, stack, context, line, offset) do
    parse_date__58(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__58(rest, acc, stack, context, line, offset) do
    parse_date__59(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__59(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__60(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__59(<<"november", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__59(<<"february", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__59(<<"december", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__59(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__59(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__59(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__59(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__59(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__59(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__59(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__59(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__59(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__60(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__59(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date__60(rest, acc, stack, context, line, offset) do
    parse_date__61(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__61(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__62(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__61(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__62(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__62(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__63(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__63(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__64(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__64(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__65(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__65(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__56(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__66(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__57(rest, [], stack, context, line, offset)
  end

  defp parse_date__67(rest, acc, stack, context, line, offset) do
    parse_date__68(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__68(rest, acc, stack, context, line, offset) do
    parse_date__69(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__69(rest, acc, stack, context, line, offset) do
    parse_date__75(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__71(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__72(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__71(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__66(rest, acc, stack, context, line, offset)
  end

  defp parse_date__72(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__66(rest, acc, stack, context, line, offset)
  end

  defp parse_date__72(rest, acc, stack, context, line, offset) do
    parse_date__73(rest, acc, stack, context, line, offset)
  end

  defp parse_date__73(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__70(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__74(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__71(rest, [], stack, context, line, offset)
  end

  defp parse_date__75(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__76(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__75(rest, acc, stack, context, line, offset) do
    parse_date__74(rest, acc, stack, context, line, offset)
  end

  defp parse_date__76(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__70(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__70(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__77(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__77(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__78(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__78(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__56(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__56(rest, acc, stack, context, line, offset) do
    parse_date__82(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__80(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__79(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__81(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__80(rest, [], stack, context, line, offset)
  end

  defp parse_date__82(rest, acc, stack, context, line, offset) do
    parse_date__83(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__83(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__83(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__83(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__83(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__83(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__84(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__83(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__81(rest, acc, stack, context, line, offset)
  end

  defp parse_date__84(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__85(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__85(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__79(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__79(rest, acc, stack, context, line, offset) do
    parse_date__86(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__86(rest, acc, stack, context, line, offset) do
    parse_date__87(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__87(rest, acc, stack, context, line, offset) do
    parse_date__93(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__89(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__90(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__89(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date__90(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__54(rest, acc, stack, context, line, offset)
  end

  defp parse_date__90(rest, acc, stack, context, line, offset) do
    parse_date__91(rest, acc, stack, context, line, offset)
  end

  defp parse_date__91(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__88(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__92(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__89(rest, [], stack, context, line, offset)
  end

  defp parse_date__93(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__94(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__93(rest, acc, stack, context, line, offset) do
    parse_date__92(rest, acc, stack, context, line, offset)
  end

  defp parse_date__94(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__88(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__88(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__95(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__95(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__96(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__96(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__97(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__55(rest, [], stack, context, line, offset)
  end

  defp parse_date__98(rest, acc, stack, context, line, offset) do
    parse_date__110(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__100(rest, acc, stack, context, line, offset) do
    parse_date__101(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__101(rest, acc, stack, context, line, offset) do
    parse_date__102(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__102(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__103(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__102(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__103(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__102(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__103(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__102(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__103(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__102(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__102(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__102(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__102(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__102(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__102(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__102(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__102(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__102(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__103(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__102(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date__103(rest, acc, stack, context, line, offset) do
    parse_date__104(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__104(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__105(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__104(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__105(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__105(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__106(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__106(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__107(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__107(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__108(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__108(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__99(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__109(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__100(rest, [], stack, context, line, offset)
  end

  defp parse_date__110(rest, acc, stack, context, line, offset) do
    parse_date__111(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__111(rest, acc, stack, context, line, offset) do
    parse_date__112(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__112(rest, acc, stack, context, line, offset) do
    parse_date__118(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__114(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__115(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__114(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__109(rest, acc, stack, context, line, offset)
  end

  defp parse_date__115(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__109(rest, acc, stack, context, line, offset)
  end

  defp parse_date__115(rest, acc, stack, context, line, offset) do
    parse_date__116(rest, acc, stack, context, line, offset)
  end

  defp parse_date__116(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__113(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__117(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__114(rest, [], stack, context, line, offset)
  end

  defp parse_date__118(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__119(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__118(rest, acc, stack, context, line, offset) do
    parse_date__117(rest, acc, stack, context, line, offset)
  end

  defp parse_date__119(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__113(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__113(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__120(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__120(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__121(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__121(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__99(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__99(rest, acc, stack, context, line, offset) do
    parse_date__125(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__123(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__122(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__124(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__123(rest, [], stack, context, line, offset)
  end

  defp parse_date__125(rest, acc, stack, context, line, offset) do
    parse_date__126(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__126(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__127(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__126(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__127(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__126(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__127(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__126(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__127(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__126(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__127(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__126(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__124(rest, acc, stack, context, line, offset)
  end

  defp parse_date__127(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__128(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__128(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__122(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__122(rest, acc, stack, context, line, offset) do
    parse_date__129(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__129(rest, acc, stack, context, line, offset) do
    parse_date__130(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__130(rest, acc, stack, context, line, offset) do
    parse_date__136(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__132(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__133(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__132(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date__133(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date__133(rest, acc, stack, context, line, offset) do
    parse_date__134(rest, acc, stack, context, line, offset)
  end

  defp parse_date__134(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__131(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__135(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__132(rest, [], stack, context, line, offset)
  end

  defp parse_date__136(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__137(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__136(rest, acc, stack, context, line, offset) do
    parse_date__135(rest, acc, stack, context, line, offset)
  end

  defp parse_date__137(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__131(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__131(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__138(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__138(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__139(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__139(rest, acc, stack, context, line, offset) do
    parse_date__143(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__141(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__140(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__142(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__141(rest, [], stack, context, line, offset)
  end

  defp parse_date__143(rest, acc, stack, context, line, offset) do
    parse_date__144(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__144(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__145(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__144(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__145(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__144(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__145(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__144(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__145(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__144(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__145(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__144(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__142(rest, acc, stack, context, line, offset)
  end

  defp parse_date__145(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__146(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__146(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__140(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__140(rest, acc, stack, context, line, offset) do
    parse_date__147(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__147(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date__148(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__147(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__97(rest, acc, stack, context, line, offset)
  end

  defp parse_date__148(rest, acc, stack, context, line, offset) do
    parse_date__150(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date__150(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date__151(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__150(rest, acc, stack, context, line, offset) do
    parse_date__149(rest, acc, stack, context, line, offset)
  end

  defp parse_date__149(rest, acc, [_ | stack], context, line, offset) do
    parse_date__152(rest, acc, stack, context, line, offset)
  end

  defp parse_date__151(rest, acc, [1 | stack], context, line, offset) do
    parse_date__152(rest, acc, stack, context, line, offset)
  end

  defp parse_date__151(rest, acc, [count | stack], context, line, offset) do
    parse_date__150(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date__152(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__153(rest, [year: :lists.reverse(user_acc)] ++ acc, stack, context, line, offset)
  end

  defp parse_date__153(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__154(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__98(rest, [], stack, context, line, offset)
  end

  defp parse_date__155(rest, acc, stack, context, line, offset) do
    parse_date__167(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__157(rest, acc, stack, context, line, offset) do
    parse_date__158(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__158(rest, acc, stack, context, line, offset) do
    parse_date__159(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__159(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__160(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__159(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__160(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__159(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__160(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__159(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__160(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__159(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__159(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__159(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__159(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__159(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__159(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__159(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__159(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__159(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__160(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__159(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__154(rest, acc, stack, context, line, offset)
  end

  defp parse_date__160(rest, acc, stack, context, line, offset) do
    parse_date__161(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__161(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__162(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__161(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__162(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__162(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__163(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__163(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__164(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__164(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__165(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__165(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__156(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__166(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__157(rest, [], stack, context, line, offset)
  end

  defp parse_date__167(rest, acc, stack, context, line, offset) do
    parse_date__168(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__168(rest, acc, stack, context, line, offset) do
    parse_date__169(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__169(rest, acc, stack, context, line, offset) do
    parse_date__175(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__171(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__172(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__171(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__166(rest, acc, stack, context, line, offset)
  end

  defp parse_date__172(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__166(rest, acc, stack, context, line, offset)
  end

  defp parse_date__172(rest, acc, stack, context, line, offset) do
    parse_date__173(rest, acc, stack, context, line, offset)
  end

  defp parse_date__173(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__170(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__174(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__171(rest, [], stack, context, line, offset)
  end

  defp parse_date__175(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__176(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__175(rest, acc, stack, context, line, offset) do
    parse_date__174(rest, acc, stack, context, line, offset)
  end

  defp parse_date__176(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__170(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__170(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__177(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__177(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__178(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__178(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__156(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__156(rest, acc, stack, context, line, offset) do
    parse_date__182(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__180(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__179(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__181(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__180(rest, [], stack, context, line, offset)
  end

  defp parse_date__182(rest, acc, stack, context, line, offset) do
    parse_date__183(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__183(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__184(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__183(<<", ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__184(rest, acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__183(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__181(rest, acc, stack, context, line, offset)
  end

  defp parse_date__184(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__185(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__185(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__179(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__179(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_date__186(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_date__179(rest, acc, stack, context, line, offset) do
    parse_date__154(rest, acc, stack, context, line, offset)
  end

  defp parse_date__186(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__187(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__155(rest, [], stack, context, line, offset)
  end

  defp parse_date__188(rest, acc, stack, context, line, offset) do
    parse_date__189(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__189(rest, acc, stack, context, line, offset) do
    parse_date__190(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__190(rest, acc, stack, context, line, offset) do
    parse_date__196(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__192(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__193(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__192(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date__193(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date__193(rest, acc, stack, context, line, offset) do
    parse_date__194(rest, acc, stack, context, line, offset)
  end

  defp parse_date__194(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__191(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__195(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__192(rest, [], stack, context, line, offset)
  end

  defp parse_date__196(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__197(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__196(rest, acc, stack, context, line, offset) do
    parse_date__195(rest, acc, stack, context, line, offset)
  end

  defp parse_date__197(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__191(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__191(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__198(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__198(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__199(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__199(rest, acc, stack, context, line, offset) do
    parse_date__203(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__201(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__200(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__202(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__201(rest, [], stack, context, line, offset)
  end

  defp parse_date__203(rest, acc, stack, context, line, offset) do
    parse_date__204(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__204(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__204(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__204(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__204(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__204(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__205(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__204(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__202(rest, acc, stack, context, line, offset)
  end

  defp parse_date__205(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__206(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__206(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__200(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__200(rest, acc, stack, context, line, offset) do
    parse_date__218(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__208(rest, acc, stack, context, line, offset) do
    parse_date__209(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__209(rest, acc, stack, context, line, offset) do
    parse_date__210(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__210(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__211(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__210(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__211(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__210(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__211(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__210(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__211(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__210(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__210(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__210(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__210(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__210(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__210(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__210(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__210(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__210(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__211(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__210(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date__211(rest, acc, stack, context, line, offset) do
    parse_date__212(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__212(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__213(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__212(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__213(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__213(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__214(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__214(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__215(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__215(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__216(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__216(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__207(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__217(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__208(rest, [], stack, context, line, offset)
  end

  defp parse_date__218(rest, acc, stack, context, line, offset) do
    parse_date__219(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__219(rest, acc, stack, context, line, offset) do
    parse_date__220(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__220(rest, acc, stack, context, line, offset) do
    parse_date__226(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__222(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__223(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__222(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__217(rest, acc, stack, context, line, offset)
  end

  defp parse_date__223(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__217(rest, acc, stack, context, line, offset)
  end

  defp parse_date__223(rest, acc, stack, context, line, offset) do
    parse_date__224(rest, acc, stack, context, line, offset)
  end

  defp parse_date__224(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__221(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__225(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__222(rest, [], stack, context, line, offset)
  end

  defp parse_date__226(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__227(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__226(rest, acc, stack, context, line, offset) do
    parse_date__225(rest, acc, stack, context, line, offset)
  end

  defp parse_date__227(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__221(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__221(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__228(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__228(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__229(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__229(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__207(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__207(rest, acc, stack, context, line, offset) do
    parse_date__233(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__231(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__230(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__232(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__231(rest, [], stack, context, line, offset)
  end

  defp parse_date__233(rest, acc, stack, context, line, offset) do
    parse_date__234(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__234(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__234(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__234(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__234(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__234(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__235(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__234(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__232(rest, acc, stack, context, line, offset)
  end

  defp parse_date__235(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__236(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__236(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__230(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__230(rest, acc, stack, context, line, offset) do
    parse_date__237(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__237(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date__238(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__237(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__187(rest, acc, stack, context, line, offset)
  end

  defp parse_date__238(rest, acc, stack, context, line, offset) do
    parse_date__240(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date__240(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date__241(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__240(rest, acc, stack, context, line, offset) do
    parse_date__239(rest, acc, stack, context, line, offset)
  end

  defp parse_date__239(rest, acc, [_ | stack], context, line, offset) do
    parse_date__242(rest, acc, stack, context, line, offset)
  end

  defp parse_date__241(rest, acc, [1 | stack], context, line, offset) do
    parse_date__242(rest, acc, stack, context, line, offset)
  end

  defp parse_date__241(rest, acc, [count | stack], context, line, offset) do
    parse_date__240(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date__242(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__243(rest, [year: :lists.reverse(user_acc)] ++ acc, stack, context, line, offset)
  end

  defp parse_date__243(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__244(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__188(rest, [], stack, context, line, offset)
  end

  defp parse_date__245(rest, acc, stack, context, line, offset) do
    parse_date__246(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__246(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date__247(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__246(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date__247(rest, acc, stack, context, line, offset) do
    parse_date__249(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date__249(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date__250(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__249(rest, acc, stack, context, line, offset) do
    parse_date__248(rest, acc, stack, context, line, offset)
  end

  defp parse_date__248(rest, acc, [_ | stack], context, line, offset) do
    parse_date__251(rest, acc, stack, context, line, offset)
  end

  defp parse_date__250(rest, acc, [1 | stack], context, line, offset) do
    parse_date__251(rest, acc, stack, context, line, offset)
  end

  defp parse_date__250(rest, acc, [count | stack], context, line, offset) do
    parse_date__249(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date__251(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__252(rest, [year: :lists.reverse(user_acc)] ++ acc, stack, context, line, offset)
  end

  defp parse_date__252(rest, acc, stack, context, line, offset) do
    parse_date__256(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__254(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__253(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__255(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__254(rest, [], stack, context, line, offset)
  end

  defp parse_date__256(rest, acc, stack, context, line, offset) do
    parse_date__257(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__257(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__258(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__257(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__258(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__257(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__258(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__257(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__258(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__257(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__258(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__257(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__255(rest, acc, stack, context, line, offset)
  end

  defp parse_date__258(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__259(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__259(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__253(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__253(rest, acc, stack, context, line, offset) do
    parse_date__271(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__261(rest, acc, stack, context, line, offset) do
    parse_date__262(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__262(rest, acc, stack, context, line, offset) do
    parse_date__263(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__263(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__264(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__263(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__264(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__263(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__264(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__263(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__264(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__263(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__263(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__263(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__263(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__263(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__263(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__263(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__263(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__263(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__264(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__263(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date__264(rest, acc, stack, context, line, offset) do
    parse_date__265(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__265(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__266(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__265(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__266(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__266(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__267(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__267(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__268(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__268(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__269(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__269(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__260(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__270(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__261(rest, [], stack, context, line, offset)
  end

  defp parse_date__271(rest, acc, stack, context, line, offset) do
    parse_date__272(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__272(rest, acc, stack, context, line, offset) do
    parse_date__273(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__273(rest, acc, stack, context, line, offset) do
    parse_date__279(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__275(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__276(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__275(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__270(rest, acc, stack, context, line, offset)
  end

  defp parse_date__276(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__270(rest, acc, stack, context, line, offset)
  end

  defp parse_date__276(rest, acc, stack, context, line, offset) do
    parse_date__277(rest, acc, stack, context, line, offset)
  end

  defp parse_date__277(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__274(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__278(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__275(rest, [], stack, context, line, offset)
  end

  defp parse_date__279(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__280(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__279(rest, acc, stack, context, line, offset) do
    parse_date__278(rest, acc, stack, context, line, offset)
  end

  defp parse_date__280(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__274(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__274(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__281(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__281(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__282(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__282(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__260(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__260(rest, acc, stack, context, line, offset) do
    parse_date__286(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__284(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__283(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__285(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__284(rest, [], stack, context, line, offset)
  end

  defp parse_date__286(rest, acc, stack, context, line, offset) do
    parse_date__287(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__287(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__288(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__287(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__288(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__287(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__288(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__287(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__288(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__287(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__288(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__287(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__285(rest, acc, stack, context, line, offset)
  end

  defp parse_date__288(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__289(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__289(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__283(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__283(rest, acc, stack, context, line, offset) do
    parse_date__290(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__290(rest, acc, stack, context, line, offset) do
    parse_date__291(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__291(rest, acc, stack, context, line, offset) do
    parse_date__297(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__293(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__294(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__293(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date__294(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__244(rest, acc, stack, context, line, offset)
  end

  defp parse_date__294(rest, acc, stack, context, line, offset) do
    parse_date__295(rest, acc, stack, context, line, offset)
  end

  defp parse_date__295(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__292(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__296(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__293(rest, [], stack, context, line, offset)
  end

  defp parse_date__297(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__298(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__297(rest, acc, stack, context, line, offset) do
    parse_date__296(rest, acc, stack, context, line, offset)
  end

  defp parse_date__298(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__292(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__292(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__299(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__299(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__300(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__300(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__301(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__245(rest, [], stack, context, line, offset)
  end

  defp parse_date__302(rest, acc, stack, context, line, offset) do
    parse_date__303(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__303(rest, acc, stack, context, line, offset) do
    parse_date__304(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__304(rest, acc, stack, context, line, offset) do
    parse_date__310(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__306(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__307(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__306(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date__307(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date__307(rest, acc, stack, context, line, offset) do
    parse_date__308(rest, acc, stack, context, line, offset)
  end

  defp parse_date__308(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__305(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__309(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__306(rest, [], stack, context, line, offset)
  end

  defp parse_date__310(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__311(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__310(rest, acc, stack, context, line, offset) do
    parse_date__309(rest, acc, stack, context, line, offset)
  end

  defp parse_date__311(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__305(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__305(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__312(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__312(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__313(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__313(rest, acc, stack, context, line, offset) do
    parse_date__317(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__315(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__314(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__316(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__315(rest, [], stack, context, line, offset)
  end

  defp parse_date__317(rest, acc, stack, context, line, offset) do
    parse_date__318(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__318(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__318(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__318(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__318(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__318(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__319(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__318(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__316(rest, acc, stack, context, line, offset)
  end

  defp parse_date__319(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__320(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__320(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__314(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__314(rest, acc, stack, context, line, offset) do
    parse_date__332(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__322(rest, acc, stack, context, line, offset) do
    parse_date__323(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__323(rest, acc, stack, context, line, offset) do
    parse_date__324(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__324(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__325(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__324(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__325(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__324(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__325(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__324(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__325(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__324(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__324(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__324(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__324(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__324(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__324(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__324(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__324(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__324(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__325(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__324(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date__325(rest, acc, stack, context, line, offset) do
    parse_date__326(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__326(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__327(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__326(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__327(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__327(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__328(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__328(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__329(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__329(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__330(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__330(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__321(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__331(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__322(rest, [], stack, context, line, offset)
  end

  defp parse_date__332(rest, acc, stack, context, line, offset) do
    parse_date__333(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__333(rest, acc, stack, context, line, offset) do
    parse_date__334(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__334(rest, acc, stack, context, line, offset) do
    parse_date__340(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__336(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__337(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__336(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__331(rest, acc, stack, context, line, offset)
  end

  defp parse_date__337(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__331(rest, acc, stack, context, line, offset)
  end

  defp parse_date__337(rest, acc, stack, context, line, offset) do
    parse_date__338(rest, acc, stack, context, line, offset)
  end

  defp parse_date__338(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__335(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__339(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__336(rest, [], stack, context, line, offset)
  end

  defp parse_date__340(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__341(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__340(rest, acc, stack, context, line, offset) do
    parse_date__339(rest, acc, stack, context, line, offset)
  end

  defp parse_date__341(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__335(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__335(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__342(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__342(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__343(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__343(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__321(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__321(rest, acc, stack, context, line, offset) do
    parse_date__344(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__344(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__345(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__344(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__345(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__344(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__345(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__344(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__345(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__344(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__345(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__344(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date__345(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__346(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__346(
         <<x0, x1, x2, x3, rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       )
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) and (x2 >= 48 and x2 <= 57) and
              (x3 >= 48 and x3 <= 57) do
    parse_date__347(
      rest,
      [year: [x0, x1, x2, x3]] ++ acc,
      stack,
      context,
      comb__line,
      comb__offset + 4
    )
  end

  defp parse_date__346(rest, acc, stack, context, line, offset) do
    parse_date__301(rest, acc, stack, context, line, offset)
  end

  defp parse_date__347(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__348(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__302(rest, [], stack, context, line, offset)
  end

  defp parse_date__349(rest, acc, stack, context, line, offset) do
    parse_date__350(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__350(rest, acc, stack, context, line, offset) do
    parse_date__351(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__351(rest, acc, stack, context, line, offset) do
    parse_date__357(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__353(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__354(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__353(rest, _acc, stack, context, line, offset) do
    [_, _, _, acc | stack] = stack
    parse_date__348(rest, acc, stack, context, line, offset)
  end

  defp parse_date__354(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 48 and x0 <= 57 do
    [_, _, _, acc | stack] = stack
    parse_date__348(rest, acc, stack, context, line, offset)
  end

  defp parse_date__354(rest, acc, stack, context, line, offset) do
    parse_date__355(rest, acc, stack, context, line, offset)
  end

  defp parse_date__355(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__352(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__356(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__353(rest, [], stack, context, line, offset)
  end

  defp parse_date__357(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__358(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__357(rest, acc, stack, context, line, offset) do
    parse_date__356(rest, acc, stack, context, line, offset)
  end

  defp parse_date__358(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__352(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__352(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__359(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__359(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__360(
      rest,
      [
        day:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__360(rest, acc, stack, context, line, offset) do
    parse_date__364(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__362(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__361(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__363(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__362(rest, [], stack, context, line, offset)
  end

  defp parse_date__364(rest, acc, stack, context, line, offset) do
    parse_date__365(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__365(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__366(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__365(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__366(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__365(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__366(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__365(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__366(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__365(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__366(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__365(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__363(rest, acc, stack, context, line, offset)
  end

  defp parse_date__366(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__367(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__367(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__361(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__361(rest, acc, stack, context, line, offset) do
    parse_date__368(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__368(rest, acc, stack, context, line, offset) do
    parse_date__369(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__369(
         <<"september", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__370(rest, ["september"] ++ acc, stack, context, comb__line, comb__offset + 9)
  end

  defp parse_date__369(
         <<"november", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__370(rest, ["november"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__369(
         <<"february", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__370(rest, ["february"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__369(
         <<"december", rest::binary>>,
         acc,
         stack,
         context,
         comb__line,
         comb__offset
       ) do
    parse_date__370(rest, ["december"] ++ acc, stack, context, comb__line, comb__offset + 8)
  end

  defp parse_date__369(<<"october", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["october"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__369(<<"january", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["january"] ++ acc, stack, context, comb__line, comb__offset + 7)
  end

  defp parse_date__369(<<"august", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["august"] ++ acc, stack, context, comb__line, comb__offset + 6)
  end

  defp parse_date__369(<<"march", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["march"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__369(<<"april", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["april"] ++ acc, stack, context, comb__line, comb__offset + 5)
  end

  defp parse_date__369(<<"sept", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["sept"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__369(<<"june", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["june"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__369(<<"july", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["july"] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_date__369(<<"sep", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["sep"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"oct", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["oct"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"nov", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["nov"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"may", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["may"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"mar", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["mar"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"jun", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["jun"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"jul", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["jul"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"jan", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["jan"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"feb", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["feb"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"dec", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["dec"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"aug", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["aug"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(<<"apr", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__370(rest, ["apr"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_date__369(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_date__348(rest, acc, stack, context, line, offset)
  end

  defp parse_date__370(rest, acc, stack, context, line, offset) do
    parse_date__371(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__371(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__372(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__371(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__372(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_date__372(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__373(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__373(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__374(
      rest,
      Enum.map(user_acc, fn var -> vocal_month_to_numeric_month(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__374(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_date__375(
      rest,
      [
        month:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_date__375(rest, acc, stack, context, line, offset) do
    parse_date__379(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_date__377(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__376(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__378(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_date__377(rest, [], stack, context, line, offset)
  end

  defp parse_date__379(rest, acc, stack, context, line, offset) do
    parse_date__380(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__380(<<",", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__381(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__380(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__381(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__380(<<"/", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__381(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__380(<<"-", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__381(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__380(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_date__381(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__380(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__378(rest, acc, stack, context, line, offset)
  end

  defp parse_date__381(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__382(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_date__382(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__376(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__376(rest, acc, stack, context, line, offset) do
    parse_date__383(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_date__383(<<x0, x1, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 and (x1 >= 48 and x1 <= 57) do
    parse_date__384(rest, [x1, x0] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_date__383(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_date__348(rest, acc, stack, context, line, offset)
  end

  defp parse_date__384(rest, acc, stack, context, line, offset) do
    parse_date__386(rest, acc, [2 | stack], context, line, offset)
  end

  defp parse_date__386(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_date__387(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_date__386(rest, acc, stack, context, line, offset) do
    parse_date__385(rest, acc, stack, context, line, offset)
  end

  defp parse_date__385(rest, acc, [_ | stack], context, line, offset) do
    parse_date__388(rest, acc, stack, context, line, offset)
  end

  defp parse_date__387(rest, acc, [1 | stack], context, line, offset) do
    parse_date__388(rest, acc, stack, context, line, offset)
  end

  defp parse_date__387(rest, acc, [count | stack], context, line, offset) do
    parse_date__386(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_date__388(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_date__389(rest, [year: :lists.reverse(user_acc)] ++ acc, stack, context, line, offset)
  end

  defp parse_date__389(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_date__11(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_date__11(rest, acc, _stack, context, line, offset) do
    {:ok, acc, rest, context, line, offset}
  end

  @doc """
  Parses the given `binary` as parse_time.

  Returns `{:ok, [token], rest, context, position, byte_offset}` or
  `{:error, reason, rest, context, line, byte_offset}` where `position`
  describes the location of the parse_time (start position) as `{line, offset_to_start_of_line}`.

  To column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.

  ## Options

    * `:byte_offset` - the byte offset for the whole binary, defaults to 0
    * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`
    * `:context` - the initial context value. It will be converted to a map

  """
  @spec parse_time(binary, keyword) ::
          {:ok, [term], rest, context, line, byte_offset}
          | {:error, reason, rest, context, line, byte_offset}
        when line: {pos_integer, byte_offset},
             byte_offset: pos_integer,
             rest: binary,
             reason: String.t(),
             context: map
  def parse_time(binary, opts \\ []) when is_binary(binary) do
    context = Map.new(Keyword.get(opts, :context, []))
    byte_offset = Keyword.get(opts, :byte_offset, 0)

    line =
      case Keyword.get(opts, :line, 1) do
        {_, _} = line -> line
        line -> {line, byte_offset}
      end

    case parse_time__0(binary, [], [], context, line, byte_offset) do
      {:ok, acc, rest, context, line, offset} ->
        {:ok, :lists.reverse(acc), rest, context, line, offset}

      {:error, _, _, _, _, _} = error ->
        error
    end
  end

  defp parse_time__0(rest, acc, stack, context, line, offset) do
    parse_time__18(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_time__2(rest, acc, stack, context, line, offset) do
    parse_time__3(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__3(rest, acc, stack, context, line, offset) do
    parse_time__4(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__4(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__4(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__5(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__4(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric hour from 00-23 while processing numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__5(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    {:error,
     "did not expect numeric hour from 00-23 while processing numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__5(rest, acc, stack, context, line, offset) do
    parse_time__6(rest, acc, stack, context, line, offset)
  end

  defp parse_time__6(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__7(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__7(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__8(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__8(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__9(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__8(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__9(rest, acc, stack, context, line, offset) do
    parse_time__10(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__10(rest, acc, stack, context, line, offset) do
    parse_time__11(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__11(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__11(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__12(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__11(rest, _acc, _stack, context, line, offset) do
    {:error,
     "expected numeric minute from 00-59 while processing numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__12(<<x0, _::binary>> = rest, _acc, _stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    {:error,
     "did not expect numeric minute from 00-59 while processing numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__12(rest, acc, stack, context, line, offset) do
    parse_time__13(rest, acc, stack, context, line, offset)
  end

  defp parse_time__13(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__14(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__14(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__15(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__15(<<":", _::binary>> = rest, _acc, _stack, context, line, offset) do
    {:error,
     "did not expect numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\", followed by numeric second from 00-59, followed by string \".\" or nothing, followed by numeric subsecond up to 24 digits or nothing or numeric hour from 00-23, followed by string \":\", followed by numeric minute from 00-59, followed by string \":\"",
     rest, context, line, offset}
  end

  defp parse_time__15(rest, acc, stack, context, line, offset) do
    parse_time__16(rest, acc, stack, context, line, offset)
  end

  defp parse_time__16(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__17(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_time__2(rest, [], stack, context, line, offset)
  end

  defp parse_time__18(rest, acc, stack, context, line, offset) do
    parse_time__19(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__19(rest, acc, stack, context, line, offset) do
    parse_time__20(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__20(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__20(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__21(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__20(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__21(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__21(rest, acc, stack, context, line, offset) do
    parse_time__22(rest, acc, stack, context, line, offset)
  end

  defp parse_time__22(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__23(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__23(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__24(
      rest,
      [
        hour:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__24(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__25(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__24(rest, acc, stack, context, line, offset) do
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__25(rest, acc, stack, context, line, offset) do
    parse_time__26(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__26(rest, acc, stack, context, line, offset) do
    parse_time__27(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__27(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__27(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__28(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__27(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__28(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__28(rest, acc, stack, context, line, offset) do
    parse_time__29(rest, acc, stack, context, line, offset)
  end

  defp parse_time__29(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__30(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__30(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__31(
      rest,
      [
        minute:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__31(<<":", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__32(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__31(rest, acc, stack, context, line, offset) do
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__32(rest, acc, stack, context, line, offset) do
    parse_time__33(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__33(rest, acc, stack, context, line, offset) do
    parse_time__34(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__34(<<"00", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["00"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"01", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["01"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"02", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["02"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"03", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["03"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"04", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["04"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"05", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["05"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"06", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["06"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"07", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["07"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"08", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["08"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"09", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["09"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"59", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["59"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"58", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["58"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"57", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["57"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"56", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["56"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"55", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["55"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"54", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["54"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"53", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["53"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"52", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["52"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"51", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["51"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"50", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["50"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"49", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["49"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"48", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["48"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"47", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["47"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"46", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["46"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"45", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["45"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"44", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["44"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"43", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["43"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"42", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["42"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"41", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["41"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"40", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["40"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"39", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["39"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"38", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["38"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"37", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["37"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"36", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["36"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"35", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["35"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"34", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["34"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"33", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["33"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"32", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["32"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"31", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["31"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"30", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["30"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"29", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["29"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"28", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["28"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"27", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["27"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"26", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["26"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"25", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["25"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"24", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["24"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"23", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["23"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"22", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["22"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"21", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["21"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"20", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["20"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"19", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["19"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"18", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["18"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"17", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["17"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"16", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["16"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"15", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["15"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"14", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["14"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"13", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["13"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"12", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["12"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"11", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["11"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"10", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["10"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__34(<<"9", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["9"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"8", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["8"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"7", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["7"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"6", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["6"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"5", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["5"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"4", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["4"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"3", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["3"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"2", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["2"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"1", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["1"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(<<"0", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__35(rest, ["0"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__34(rest, _acc, stack, context, line, offset) do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__35(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 >= 54 and x0 <= 57 do
    [_, acc | stack] = stack
    parse_time__17(rest, acc, stack, context, line, offset)
  end

  defp parse_time__35(rest, acc, stack, context, line, offset) do
    parse_time__36(rest, acc, stack, context, line, offset)
  end

  defp parse_time__36(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__37(
      rest,
      Enum.map(user_acc, fn var -> to_integer(var) end) ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__37(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__38(
      rest,
      [
        second:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__38(<<".", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__39(rest, [] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__38(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__39(rest, [] ++ acc, stack, context, comb__line, comb__offset)
  end

  defp parse_time__39(rest, acc, stack, context, line, offset) do
    parse_time__43(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_time__41(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__40(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__42(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_time__41(rest, [], stack, context, line, offset)
  end

  defp parse_time__43(rest, acc, stack, context, line, offset) do
    parse_time__44(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__44(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_time__45(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__44(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_time__42(rest, acc, stack, context, line, offset)
  end

  defp parse_time__45(rest, acc, stack, context, line, offset) do
    parse_time__47(rest, acc, [23 | stack], context, line, offset)
  end

  defp parse_time__47(<<x0, rest::binary>>, acc, stack, context, comb__line, comb__offset)
       when x0 >= 48 and x0 <= 57 do
    parse_time__48(rest, [x0] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__47(rest, acc, stack, context, line, offset) do
    parse_time__46(rest, acc, stack, context, line, offset)
  end

  defp parse_time__46(rest, acc, [_ | stack], context, line, offset) do
    parse_time__49(rest, acc, stack, context, line, offset)
  end

  defp parse_time__48(rest, acc, [1 | stack], context, line, offset) do
    parse_time__49(rest, acc, stack, context, line, offset)
  end

  defp parse_time__48(rest, acc, [count | stack], context, line, offset) do
    parse_time__47(rest, acc, [count - 1 | stack], context, line, offset)
  end

  defp parse_time__49(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__50(
      rest,
      [microsecond: :lists.reverse(user_acc)] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__50(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__40(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__40(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__1(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__1(rest, acc, stack, context, line, offset) do
    parse_time__51(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__51(<<" ", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__52(rest, acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__51(<<rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__52(rest, acc, stack, context, comb__line, comb__offset)
  end

  defp parse_time__52(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc
    parse_time__53(rest, [] ++ acc, stack, context, line, offset)
  end

  defp parse_time__53(rest, acc, stack, context, line, offset) do
    parse_time__57(rest, [], [{rest, context, line, offset}, acc | stack], context, line, offset)
  end

  defp parse_time__55(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__54(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__56(_, _, [{rest, context, line, offset} | _] = stack, _, _, _) do
    parse_time__55(rest, [], stack, context, line, offset)
  end

  defp parse_time__57(rest, acc, stack, context, line, offset) do
    parse_time__58(rest, [], [acc | stack], context, line, offset)
  end

  defp parse_time__58(<<"am", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["am"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__58(<<"a.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["a.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_time__58(<<"a.m.", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["a.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_time__58(<<"a_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["a_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_time__58(<<"pm", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["pm"] ++ acc, stack, context, comb__line, comb__offset + 2)
  end

  defp parse_time__58(<<"p.m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["p.m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_time__58(<<"p.m.", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["p.m."] ++ acc, stack, context, comb__line, comb__offset + 4)
  end

  defp parse_time__58(<<"p_m", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["p_m"] ++ acc, stack, context, comb__line, comb__offset + 3)
  end

  defp parse_time__58(<<"a", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["a"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__58(<<"p", rest::binary>>, acc, stack, context, comb__line, comb__offset) do
    parse_time__59(rest, ["p"] ++ acc, stack, context, comb__line, comb__offset + 1)
  end

  defp parse_time__58(rest, _acc, stack, context, line, offset) do
    [acc | stack] = stack
    parse_time__56(rest, acc, stack, context, line, offset)
  end

  defp parse_time__59(<<x0, _::binary>> = rest, _acc, stack, context, line, offset)
       when x0 === 116 or x0 === 109 or x0 === 97 or x0 === 115 or x0 === 100 or x0 === 101 or
              x0 === 111 or
              x0 === 108 or x0 === 107 do
    [acc | stack] = stack
    parse_time__56(rest, acc, stack, context, line, offset)
  end

  defp parse_time__59(rest, acc, stack, context, line, offset) do
    parse_time__60(rest, acc, stack, context, line, offset)
  end

  defp parse_time__60(rest, user_acc, [acc | stack], context, line, offset) do
    _ = user_acc

    parse_time__61(
      rest,
      [
        am_pm:
          case :lists.reverse(user_acc) do
            [one] -> one
            many -> raise "unwrap_and_tag/3 expected a single token, got: #{inspect(many)}"
          end
      ] ++ acc,
      stack,
      context,
      line,
      offset
    )
  end

  defp parse_time__61(rest, acc, [_, previous_acc | stack], context, line, offset) do
    parse_time__54(rest, acc ++ previous_acc, stack, context, line, offset)
  end

  defp parse_time__54(rest, acc, _stack, context, line, offset) do
    {:ok, acc, rest, context, line, offset}
  end
end
